/*
ͻ
 Vincent Wilding           SilverSoft Micro       PC Consulting Services 
Ķ
 File:                C:\SILVERSO.FT!\ANSITEST.C                         
 Initial File Date:   03/31/90                                           
 Description:         Test for presence of ANSI driver:   Issue a Device 
                      status reort (ESC[6n) If we get back a CPR (Cursor 
                      Position Report, ESC[row,columnR ) we know we have 
                      an ANSI driver. Set ERRORLEVEL >0 if no ANSI driver
 Version history:     1.00a 4/4/90 initial shareware release             
ͼ
*/
#include <vcfw.h>
COPYRIGHT_90;                         /* Copyright 1990 SilverSoft Micro */
void main (int argc, char *argv[])
{

   int ansitest();
   char sw1 = '*';
   if (argc > 0) sw1 = *argv[1];
   if (sw1 == 'S') sw1 = 's';          /* SHADDAP mode, no o/p */
   if (sw1 == 'Q') sw1 = 'q';          /* Quiet mode, report only if absent */
   switch ((char) ansitest())
      {
      case 0:
          if (sw1 != 's')
          printf("\nANSI screen driver absent");
          exit(1);                              /* ERRORLEVEL 1 = No ANSI   */
      case 1:
          if (sw1 != 's')
            if (sw1 != 'q')
                printf("\nANSI screen driver found");
          exit(0);                             /* ERRORLEVEL 0 = hunky dory */
      case 2:
          if (sw1 != 's')
          printf("\nANSITEST reports unrecognized response to DSR");
          exit(2);                              /* ERRORLEVEL 2 = No ANSI   */
      default:
          printf("\nInvalid ANSITEST response");
                                        /* always print, should never happen*/
          exit(999);                              /* ERRORLEVEL 999 = UH OH */
      }
}
int ansitest()
{
   printf("\x1b[6n");                                       /* request DSR */
   if (!kbhit())                         /* if nothing in KBD bfr, no ANSI */
      {
      printf("\r    \r");    /* if no ANSI, erase ESCape sequence  */
      return(0);
      }
   else if (getch() =='\x1b')              /* if 1st Char in buffer is ESC */
      {                               /* we have an ANSI compatible Driver */
      char ch = '*';
      do
         ch = getch();                             /* Soak up rest of CPR  */
      while (ch != '\x0d');                      /* up to and including CR */
      return(1);
      }
   else
      printf("\r    \r");    /* if no ANSI, erase ESCape sequence  */
      return(2);          /* ANSI screen driver not recognized if present */
                        /* some character is 1st in buffer other than 27h */
}