#include <stdio.h>
#include <dos.h>
#include <math.h>
#include <dir.h>
#include <stdlib.h>

#include "FAGE.H"


struct  date d;					 /* DOS.H  DATE structure */

int when = 0;
int ret;

char *amonth[] = { "???",                      /* Element 0 */
						 "Jan", "Feb", "Mar", "Apr",
						 "May", "Jun", "Jul", "Aug",
						 "Sep", "Oct", "Nov", "Dec" };

unsigned int  dmonth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };


void  julday(pjd)
struct juldate *pjd;
	{
	long m1,m2,m3;

	m1=1461L*(pjd->year+4800L + (pjd->month-14L)/12L)/4L;
	m2=367L*(pjd->month-2L-(pjd->month-14L)/12L*12L)/12L;
	m3=3L*((pjd->year+4900L+(pjd->month-14L)/12L)/100L)/4L;
	pjd->julian=(long)(pjd->day-32075L+m1+m2-m3);
	}

/**********************  FUNCTIONS ****************************/

void calday(pjd)
struct juldate *pjd;
	{
	long l,n,year,month,day;
	l=pjd->julian+68569;
	n=4*l/146097;
	l=l-(146097*n+3)/4L;
	year=4000*(l+1)/1461001;
	l=l-1461L* year/4L + 31;
	month=80*l/2447L;
	day=l-2447* month/80L;
	l=month/11L;
	month=month+2-12*l;
	year=100*(n-49)+ year +l;
	pjd->year=(int)year;
	pjd->month=(int)month;
	pjd->day=(int)day;

	;
	}

void findmod(s)
unsigned char s[];

	{

	static char allstr[]={"*.*"};
	char *pallstr;
	struct date dnow;
	struct dosdta my_dta;
	struct juldate jdnow;
	struct juldate jdfile;

	char   holddir[65];
	union  REGS   regs;
	int      daysold;

	pallstr=&allstr[0];
	getdate(&dnow);
	jdnow.year=dnow.da_year;
	jdnow.month=dnow.da_mon;
	jdnow.day=dnow.da_day;
	julday(&jdnow);

	ret=chdir((const char *)s);    					  /* change to specified directory */
	regs.x.si = (short)&holddir[1];  /* area to hold current directory */
	regs.x.ax = 0x4700;              /* get current directory function */
	regs.x.dx = 0;                   /* default drive */
	ret=intdos(&regs,&regs);
	holddir[0] = '\\';
	if(holddir[1] == '\0') holddir[0] = '\0';

   regs.x.dx = (short)&my_dta;      /* new DTA */
   regs.x.ax = 0x1a00;              /* set DTA function */
	ret=intdos(&regs,&regs);             /* do it ... */

   regs.x.ax = 0x4e00;              /* find first */
	regs.x.dx = (unsigned int)pallstr;   /* *.* */
	regs.x.cx = 0x10;                /* include subdirectories */
	ret=intdos(&regs,&regs);             /* do it */

	my_dta.attrib=0;                /* Initialize it (for LINT !) */

	while(regs.x.cflag == 0) {
		if((my_dta.attrib & 0x10) && (my_dta.fspec[0] != '.'))
			{
			findmod(my_dta.fspec);
			ret=chdir("..");
			regs.x.dx = (short)&my_dta;      /* new DTA */
			regs.x.ax = 0x1a00;              /* set DTA function */
			ret=intdos(&regs,&regs);             /* do it ... */
			}
		else
			{
			if (  ( (when >0)  && ((int)my_dta.fdate >= abs(when) ) ) ||
					( (when <=0) && ((int)my_dta.fdate <  abs(when) ) ) )
				{
				jdfile.year = (my_dta.fdate >> 9) + 1980;
				jdfile.month= ((my_dta.fdate & 0x1e0) >> 5);
				jdfile.day  =  (my_dta.fdate & 0x1f);
				julday(&jdfile);
				daysold=(int)(jdnow.julian-jdfile.julian);
				printf("%s-%02.2d-%d  (%5d)    %s\\%s\n",
						amonth[jdfile.month],jdfile.day,jdfile.year,daysold,
						holddir,my_dta.fspec);
				}
			}

		regs.x.ax = 0x4f00;           /* find first */
		ret=intdos(&regs,&regs);          /* do it */
		}

	}


/*********************** MAIN ********************************/

void main(argc,argv)
int  argc;
char **argv;
	{
	static unsigned char rootstr[]={"/"};
	unsigned char *prootstr;
	union  REGS   regs;
	char holddir[65];

	struct juldate jdtoday;
	struct juldate jdhistory;

	unsigned int mm,dd,yy;
	int days;


		ret=0;					/* keep lint happy !*/
		ret=ret+1;
		prootstr=&rootstr[0];
      getdate(&d);
		mm=(unsigned char)(d.da_mon);
		dd=(unsigned char)(d.da_day);
		yy=(unsigned int)(d.da_year);

      jdtoday.year=d.da_year;
      jdtoday.month=d.da_mon;
      jdtoday.day=d.da_day;

		if(argc ==2)
			{
			days=atoi(argv[1]);
			}

   if((argc != 4) && (argc != 2))
      {
      fprintf(stderr,"Format is either : FAGE mm dd yy\n\n");
      fprintf(stderr,"    or           : FAGE day_offset_from_today\n\n");
      fprintf(stderr,"  + day_offset_from_today = FILES AFTER  ABSOLUTE OFFSET\n");
      fprintf(stderr,"  - day_offset_from_today = FILES BEFORE ABSOLUTE OFFSET\n\n");
      exit(100);
      }
   if(argc ==4)
      {
		mm = (unsigned int)atoi(argv[1]);
		dd = (unsigned int)atoi(argv[2]);
		yy = (unsigned int)atoi(argv[3]);
      }
   if((mm < 1) || (mm > 12)) {
      fprintf(stderr,"When did they change the number of months in a year?\n");
      exit(4);
      }
      
   if((( mm != 2) && (dmonth[mm-1] < dd)) || ((mm == 2) && (dd > 29))) {
      fprintf(stderr,"When did they change the number of days in %s?\n",amonth[mm-1]);
      exit(4);
      }
   
	if(((yy < 1980) && (yy > 99)) || (yy < 80))
		{
		fprintf(stderr,"Bad year, must be >= 1980 or >79 and < 100\n");
		exit(4);
		}

	printf("      Todays    date is  %s-%02.2d-%d\n",
				 amonth[jdtoday.month],jdtoday.day,jdtoday.year);
	if (argc ==4)
		{
		printf("       Files   since     ");
		}
	if (argc ==2)
		{
		if (days >=0)
			{
			printf("       Files   on/after  ");
			}
		else
			{
			printf("       Files   before    ");
			}

		julday(&jdtoday);
		jdhistory.julian=jdtoday.julian-abs(days);
		calday(&jdhistory);

		yy=(unsigned int)jdhistory.year;
		mm=(unsigned int)jdhistory.month;
		dd=(unsigned int)jdhistory.day;
		}
	printf("%s-%02.2d-%d\n\n",amonth[mm],dd,yy);
	printf("==F.Date===   F.AGE     ======== File Name ========\n");
	if (yy >= 1980) yy -= 1980;
	else yy -= 80;

   yy = yy << 9;
   mm = mm << 5;
	when = (int)(yy | mm | dd);

   if ((argc ==2 ) && (days <0))
		{
		when = -when;         /* set sign of when for BEFORE/AFTER mode */
		}

/* printf("x\'%4.4x\'\n",when); */

	regs.x.ax = 0x4700;              /* get current directory */
   regs.x.si = (short)&holddir[1];  /* where to put it */
   regs.x.dx = 0;                   /* default drive */
	ret=intdos(&regs,&regs);         /* do it ... */
	holddir[0] = '\\';               /* start off with backslash */
	findmod(prootstr);               /* start at root directory */
	ret=chdir(holddir);              /* change to original directory */

	}

/************************* END of PROGRAM ************************/