#include <stdio.h>
#include <dos.h>

struct dosdta {
   unsigned char  rsv[21];          /* reserved for DOS */
   unsigned char  attrib;           /* attribute found */
   unsigned int   ftime;            /* file's time */
   unsigned int   fdate;            /* file's date */
   long           fsize;            /* file size */
   unsigned char  fspec[13];        /* file name.typ,0 */
   };

struct  date d;					 /* DOS.H  DATE structure */

struct juldate {               /* Define JULIAN DATE Structure */
	long julian;                     /* Julian date  */
	int  year;                       /* year ie 1990 */
	int  month;                      /* month 1-12   */
	int day;                         /* day   1-28/31*/
	};

int now =0;
int when = 0;

char *amonth[] = { "???",                      /* Element 0 */
						 "Jan", "Feb", "Mar", "Apr",
						 "May", "Jun", "Jul", "Aug",
						 "Sep", "Oct", "Nov", "Dec" };

int   dmonth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };


void  julday(pjd)
struct juldate *pjd;
	{
	long m1,m2,m3;

	m1=1461L*(pjd->year+4800L + (pjd->month-14L)/12L)/4L;
	m2=367L*(pjd->month-2L-(pjd->month-14L)/12L*12L)/12L;
	m3=3L*((pjd->year+4900L+(pjd->month-14L)/12L)/100L)/4L;
	pjd->julian=(long)(pjd->day-32075L+m1+m2-m3);
	}

/**********************  FUNCTIONS ****************************/

void calday(pjd)
struct juldate *pjd;
	{
	long l,n,year,month,day;
	l=pjd->julian+68569;
	n=4*l/146097;
	l=l-(146097*n+3)/4L;
	year=4000*(l+1)/1461001;
	l=l-1461L* year/4L + 31;
	month=80*l/2447L;
	day=l-2447* month/80L;
	l=month/11L;
	month=month+2-12*l;
	year=100*(n-49)+ year +l;
	pjd->year=(int)year;
	pjd->month=(int)month;
	pjd->day=(int)day;

	;
	}

void findmod(s)
char *s;
	{
	static char allstr[] = "*.*";
	struct date d;
	struct dosdta my_dta;
	struct juldate jdnow;
	struct juldate jdfile;
	char   holddir[65];
	union  REGS   regs;
	unsigned      i,daysold;

	getdate(&d);
	jdnow.year=d.da_year;
	jdnow.month=d.da_mon;
	jdnow.day=d.da_day;
	julday(&jdnow);

	chdir(s);                        /* change to specified directory */
	regs.x.si = (short)&holddir[1];  /* area to hold current directory */
	regs.x.ax = 0x4700;              /* get current directory function */
	regs.x.dx = 0;                   /* default drive */
	intdos(&regs,&regs);
	holddir[0] = '\\';
	if(holddir[1] == '\0') holddir[0] = '\0';

   regs.x.dx = (short)&my_dta;      /* new DTA */
   regs.x.ax = 0x1a00;              /* set DTA function */
   intdos(&regs,&regs);             /* do it ... */

   regs.x.ax = 0x4e00;              /* find first */
   regs.x.dx = (short)&allstr[0];   /* *.* */
   regs.x.cx = 0x10;                /* include subdirectories */
   intdos(&regs,&regs);             /* do it */

	while(regs.x.cflag == 0) {
		if((my_dta.attrib & 0x10) && (my_dta.fspec[0] != '.'))
			{
			findmod(my_dta.fspec);
			chdir("..");
			regs.x.dx = (short)&my_dta;      /* new DTA */
			regs.x.ax = 0x1a00;              /* set DTA function */
			intdos(&regs,&regs);             /* do it ... */
			}
		else
			{
			if (  ( (when >0)  && (my_dta.fdate >= abs(when) ) ) ||
					( (when <=0) && (my_dta.fdate <  abs(when) ) ) )
				{
				jdfile.year = (my_dta.fdate >> 9) + 1980;
				jdfile.month= ((my_dta.fdate & 0x1e0) >> 5);
				jdfile.day  =  (my_dta.fdate & 0x1f);
				julday(&jdfile);
				daysold=jdnow.julian-jdfile.julian;
				printf("%s-%02.2d-%d  (%5d)    %s\\%s\n",
						amonth[jdfile.month],jdfile.day,jdfile.year,daysold,
						holddir,my_dta.fspec);
				}
			}

		regs.x.ax = 0x4f00;           /* find first */
		intdos(&regs,&regs);          /* do it */
		}
	}


/*********************** MAIN ********************************/

void main(argc,argv)
int  argc;
char **argv;
	{
	union  REGS   regs;
	char holddir[65];

	struct juldate jdtoday;
	struct juldate jdhistory;

	int mm,dd,yy;
	int days;

      getdate(&d);
      mm=(d.da_mon);
      dd=(d.da_day);
      yy=d.da_year;

      jdtoday.year=d.da_year;
      jdtoday.month=d.da_mon;
      jdtoday.day=d.da_day;

	if(argc ==2)
		{
		days=atoi(argv[1]);
		}

   if((argc != 4) && (argc != 2))
      {
      fprintf(stderr,"Format is either : FAGE mm dd yy\n\n");
      fprintf(stderr,"    or           : FAGE day_offset_from_today\n\n");
      fprintf(stderr,"  + day_offset_from_today = FILES AFTER  ABSOLUTE OFFSET\n");
      fprintf(stderr,"  - day_offset_from_today = FILES BEFORE ABSOLUTE OFFSET\n\n");
      exit(100);
      }
   if(argc ==4)
      {
      mm = atoi(argv[1]);
      dd = atoi(argv[2]);
      yy = atoi(argv[3]);
      }
   if((mm < 1) || (mm > 12)) {
      fprintf(stderr,"When did they change the number of months in a year?\n");
      exit(4);
      }
      
   if((( mm != 2) && (dmonth[mm-1] < dd)) || ((mm == 2) && (dd > 29))) {
      fprintf(stderr,"When did they change the number of days in %s?\n",amonth[mm-1]);
      exit(4);
      }
   
	if(((yy < 1980) && (yy > 99)) || (yy < 80))
		{
		fprintf(stderr,"Bad year, must be >= 1980 or >79 and < 100\n");
		exit(4);
		}

	printf("      Todays    date is  %s-%02.2d-%d\n",
				 amonth[jdtoday.month],jdtoday.day,jdtoday.year);
	if (argc ==4)
		{
		printf("       Files   since     ");
		}
	if (argc ==2)
		{
		if (days >=0)
			{
			printf("       Files   on/after  ");
			}
		else
			{
			printf("       Files   before    ");
			}

		julday(&jdtoday);
		jdhistory.julian=jdtoday.julian-abs(days);
		calday(&jdhistory);

		yy=jdhistory.year;
		mm=jdhistory.month;
		dd=jdhistory.day;
		}
	printf("%s-%02.2d-%d\n\n",amonth[mm],dd,yy);
	printf("==F.Date===   F.AGE     ======== File Name ========\n");
	if (yy >= 1980) yy -= 1980;
	else yy -= 80;

   yy = yy << 9;
   mm = mm << 5;
   when = (yy | mm | dd);

   if ((argc ==2 ) && (days <0))
		{
		when = -when;         /* set sign of when for BEFORE/AFTER mode */
		}

/* printf("x\'%4.4x\'\n",when); */

	regs.x.ax = 0x4700;              /* get current directory */
   regs.x.si = (short)&holddir[1];  /* where to put it */
   regs.x.dx = 0;                   /* default drive */
   intdos(&regs,&regs);             /* do it ... */
   holddir[0] = '\\';               /* start off with backslash */
   findmod("/");                    /* start at root directory */
   chdir(holddir);                  /* change to original directory */

	}

/************************* END of PROGRAM ************************/