/* MOVE.C  Dos based file mover
 * This routine has been tested on Dos 5.0 and a Novell Network
 *
 * This source and compiled executable is FreeWare and as such
 * carries NO WARRANTY what so ever! Use at your on RISK!
 * This source and executable may be copied as long as this
 * header is contained in the source and the accompanying
 * DOC file is also sent.
 * I sent some time making sure that most Errors are accounted
 * for. If you make an improvement to this routine I'd like to
 * see it (just out of curiousity).
 *
 * Copyright (c) 1993 John W. Barton Jr.
 * 1648 DENA DR.
 * Memphis, TN. 38127
 * (901) 357-0805
 *
 */


#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <direct.h>
#include <errno.h>

void main(int argc, char *argv[])
{
	char fn[14]="",fulnam1[_MAX_PATH]="",fulnam2[_MAX_PATH]="";
	char wname[_MAX_PATH]="", nname[_MAX_PATH]="";
	char outpath[_MAX_PATH]="", temp[_MAX_PATH]="";
	char drive1[_MAX_DRIVE]="", dir1[_MAX_DIR]="";
	char fnam1[_MAX_FNAME]="", ext1[_MAX_EXT]="";
	char drive2[_MAX_DRIVE]="", dir2[_MAX_DIR]="";
	char *fnam2="", *ext2="", dirt[_MAX_DIR]="", *fnamet="", *extt="";
	long unsigned cnt=0,nmove=0;

	struct find_t find;

	printf("\nFile mover 1.0\n Copyright (c) 1993 John W. Barton Jr.");
	if(argc < 2)
	{
	printf( "\n SYNTAX: MOVE <wildfilespec> [sub-dir destination]\n" );
	printf( " Example: MOVE c:\\temp\\*.bat c:\\dos\n" );
	exit(2);
	}
	if(argc > 2)
	{
		strcpy(outpath,argv[2]);
		if( outpath[strlen(outpath)-1] != ':' && outpath[strlen(outpath)-1] != '\\')
		  strcat(outpath,"\\");
		_splitpath( outpath, drive2, dir2, fnam2, ext2 );
	};

	if(strlen(drive2) == 0)
	{
		getcwd(temp,_MAX_PATH);
		strcat(temp,"\\*,*");
		_splitpath( temp, drive2, dirt, fnamet, extt);
	};
	if(argc < 3)
	{
	strcpy(dir2,dirt);
	};
	sprintf(outpath,"%s%s", drive2, dir2);
	strcpy(temp,outpath);
	if(temp[strlen(temp)-1] == '\\')
	   temp[strlen(temp)-1] = '\0';

	if( _dos_findfirst( temp, _A_SUBDIR, &find) && stricmp(dir2,"\\") != 0)
	{
		printf("\n No Sub-directory at %s\n",outpath);
		exit(1);
	}

	_fullpath(fulnam1,argv[1],_MAX_PATH);
	_splitpath(fulnam1,drive1,dir1,fnam1,ext1);
	_makepath(fulnam2,drive2,dir2,fnam1,ext1);
	if(stricmp(drive1,drive2) != 0)
	 {
		printf("\n Use Copy and Delete to Move across Drives!");
		printf("\n Specs were %s -> %s\n",fulnam1,fulnam2);
		exit(1);
	 };
	if(stricmp(fulnam1,fulnam2) == 0)
	 {
		printf("\n What? There's nothing to do!");
		printf("\n Specs were %s -> %s\n",fulnam1,fulnam2);
		exit(1);
	 };
	printf("\n Specs are %s -> %s\n",fulnam1,fulnam2);
	/* Find first matching file, then find additional matches. */

	if( !_dos_findfirst( argv[1],
	 _A_ARCH|_A_RDONLY|_A_SYSTEM|_A_HIDDEN|_A_VOLID|_A_NORMAL,
	 &find ) || strlen(argv[2]) == 0)
	{
		strcpy(fn,find.name);
		strcpy(wname,drive1);
		strcat(wname,dir1);
		strcat(wname,fn);
		strcpy(nname,outpath);
		strcat(nname,fn);
		printf("\n Proceed?<Ctrl-C> to Abort:");
		getch();
		printf("\r Moving %s to %s                              ",wname,nname);
		if(rename(wname,nname) != 0)
		{
			nmove=1;
			printf("\r File %s NOT Moved\n",wname);
		}
		cnt=1;
	}
	else
	{
		printf( "\n  BAD File spec given\n");
		printf( "  SYNTAX: MOVE <wildfilespec> <destination>\n" );
		exit( 1 );
	};

	while( !_dos_findnext( &find ) )
	{
		strcpy(fn,find.name);
		strcpy(wname,drive1);
		strcat(wname,dir1);
		strcat(wname,fn);
		strcpy(nname,outpath);
		strcat(nname,fn);
		printf("\r Moving %s to %s                        ",wname,nname);
		if(rename(wname,nname) != 0)
		{
			printf("\rFile %s NOT Moved may exist on Target:                 \n",wname);
			nmove++;
		}
		cnt++;
	};
	printf("\n %lu of %lu file(s) moved\n\n",cnt - nmove, cnt);
	exit( 0 );
}

