
          TITLE   PrtScr - Hardcopy vom Textbildschirm einmal anders
          NAME    PRTSCR
  ;
  ;       PrtScr  -  (Fast) Originalgetreue Hardcopy von Textbildschirmen
  ;
  ; Der Ausdruck erfolgt im originalgetreuen 8*14 Pixel groen Zeichensatz
  ; auf dem Drucker in unterschiedlichen Graustufen.
  ;
  ; Harald Albrecht  12/'89                        Version 1.2
  ; Mit TASM (oder MASM) bersetzen und COM-File erzeugen
  ; (TLINK /t PRTSCR  oder  LINK PRTSCR; EXE2BIN PRTSCR PRTSCR.COM)
  ; ct 04/90 S.458

  BIOS    SEGMENT AT 0040H                ; Einige Variablen im BIOS-
          ORG     49H                     ; Datensegment
  @CRT_MODE       DB      ?               ; Aktueller Videomodus
          ORG     84H
  @ROWS           DB      ?               ; Anzahl Zeilen/Seite - 1
          ORG     100H
  @STATUS_BYTE    DB      ?               ; Status PrtScr
  BIOS    ENDS

  CODE    SEGMENT
          ASSUME  CS:CODE,DS:CODE
          ORG     100H                    ; Es ist ein .COM-File
          LOCALS                          ; Lokale Symbole freigeben.

  PixelH  EQU     1280                    ; Anzahl der Pixel horizontal

  Store   MACRO   Distance                ;; Einige Macros, um die Arbeit
          LOCAL   Dist                    ;; zu erleichtern...
  Dist    =       Distance
          IRP     Reg,<BH,BL,AH,AL,BH,BL,AH,AL>
          MOV     [DI+Dist],Reg
  Dist    =       Dist+1
          ENDM
          ENDM

  ReptC   MACRO   Cmd,Distance
          LOCAL   Dist
  Dist    =       Distance
          IRP     Reg,<AH,AL,CH,CL>
          Cmd     Reg,[BX+Dist]
  Dist    =       Dist+1
          ENDM
          ENDM

  Cmd     MACRO   Cmd,Paras               ;; Einen Befehl mit unter-
          IRP     Op,<&Paras>             ;; schiedlichen Parametern
          Cmd     Op                      ;; wiederholen
          ENDM
          ENDM

  START:  JMP     INSTALL                 ; gleich weiter zur Installation

          ASSUME  CS:CODE,DS:CODE,ES:BIOS
  PrtScr PROC FAR
          Cmd     PUSH,<DS,ES,AX>
          MOV     AX,0040H                ; Das BIOS-Datensegment adres-
          MOV     ES,AX                   ; sieren
          PUSH    CS                      ; DS auf das Programm richten.
          POP     DS
          Cmd     PUSH,<BX,CX,DX,SI,DI,BP>; Die restlichen Register retten
          MOV     AL,1                    ; Das Status-Flag in jedem Fall
          XCHG    ES:[@STATUS_BYTE],AL    ; auf 1 (=busy) setzen und ber-
          CMP     AL,1                    ; prfen, ob das Flag bereits
          JNZ     @@PrtScr1               ; vorher busy anzeigte, da dann
          JMP     @@Bye                   ; keine weiteren Aktionen unter-
  @@PrtScr1:                              ; nommen werden drfen.
          STI                             ; Ints immer eingeschaltet!
          MOV     AH,2                    ; Zuerst den Status des Druckers
          XOR     DX,DX                   ; berprfen: Papier eingelegt
          INT     17H                     ; und nicht busy ?
          XOR     AH,80H                  ; not busy invertieren
          TEST    AH,0A0H                 ; und Paper out ? Wenn der
          JZ      @@PrtScr2               ; Drucker bereit ist, drucken.
          MOV     ES:[@STATUS_BYTE],0FFH  ; Keine Hardcopy erfolgt.
          JMP     @@Bye
  @@PrtScr2:
          MOV     AH,0FH                  ; Die Breite des Bildschirms so-
          INT     10H                     ; wie die aktive Seite erfragen.
          CMP     AL,7                    ; Nur in den farbigen Textmodi
          JZ      @@PrtScr3               ; und dem monochromen Textmodus
          CMP     AL,3                    ; der EGA/VGA-Karte aktiv werden
          JBE     @@PrtScr3
          MOV     ES:[@STATUS_BYTE],0     ; ...mu wieder gelscht werden!
          Cmd     POP,<BP,DI,SI,DX,CX,BX,AX,ES,DS>
          JMP     DWORD PTR CS:[OldINT5]  ; PrtScr weiterreichen...
  @@PrtScr3:
          MOV     CL,AH                   ; Die Ausmae des Bildes fr
          MOV     CH,ES:[@ROWS]           ; spter retten
          INC     CH
          PUSH    CX
          MOV     AH,03H                  ; Aktuelle Cursorposition lesen
          INT     10H                     ; und ebenfalls retten, damit
          POP     CX                      ; der Cursor nach getaner Arbeit
          PUSH    DX                      ; wieder an sein Pltzchen zu-
                                          ; rckkehren kann.
          PUSH    CX
          MOV     [ToShift],0             ; Die notwendigen Initiali-
          CALL    ClearBuffer             ; sierungen vornehmen (Buffer
          MOV     SI,OFFSET ShortFeed     ; lschen & Zeiger einrichten)
          MOV     CX,5                    ; Druckervorschub umschalten und
          CALL    OutStr                  ; das Papier spannen
          POP     CX
          JC      @@Exit                  ; Falls Druckerfehler eintrat...
          XOR     DX,DX                   ; In der linken, oberen Ecke die
  @@NextLine:                             ; Arbeit beginnen.
          Cmd     PUSH,<CX,DX>
          MOV     CX,9                    ; Den Drucker in den Grafikmodus
          MOV     SI,OFFSET GraphOn       ; (24 Nadeln, 180 Punkte/Zoll)
          CALL    OutStr                  ; umschalten.
          Cmd     POP,<DX,CX>
          JC      @@Exit                  ; Falls Fehler auftrat, Abbruch
  @@NextChar:
          MOV     AH,02H                  ; Den Cursor auf diese (neue)
          INT     10H                     ; Stelle setzen und das Zeichen
          MOV     AH,08H                  ; sowie das Attribut von dort
          INT     10H                     ; lesen.
          CALL    InsertChar              ; Zeichen in Buffer kopieren
          JC      @@Exit
          INC     DL                      ; Eine Spalte nach rechts wan-
          CMP     DL,CL                   ; dern und berprfen, ob be-
          JNZ     @@NextChar              ; reits der rechte Rand erreicht
                                          ; ist.
          XOR     DL,DL                   ; Wieder mit dem linken Rand
          Cmd     PUSH,<CX,DX>            ; beginnen.
          MOV     SI,OFFSET CrLf          ; Noch einen Zeilenvorschub an
          MOV     CX,2                    ; den Drucker senden
          CALL    OutStr
          JC      @@PErr                  ; Druckerfehler ?
          MOV     AX,[ToShift]            ; Zeichen jeweils um 4 Pixel
          ADD     AX,4                    ; nach unten verschieben und
          CMP     AX,24                   ; berprfen, ob die aktuelle
          JNZ     @@Cont                  ; Zeile am unteren Ende des
          CALL    OutBuff                 ; Buffers anstt, da dann
          JC      @@PErr                  ; zwei Zeilen auszugeben sind.
          CALL    ClearBuffer             ; Alte Daten lschen
          XOR     AX,AX                   ; Wieder von vorne (oben)
  @@Cont: MOV     [ToShift],AX            ; beginnen
          MOV     SI,OFFSET Buff          ; Zeiger wieder auf den Anfang
          MOV     [BuffPtr],SI            ; des Buffers setzen.
          CLC                             ; Explizit zurcksetzen !
  @@PErr:
          Cmd     POP,<DX,CX>
          JC      @@Exit                  ; Druckerfehler eingetreten ?
          INC     DH                      ; Eine Zeile tiefer weiterarbei-
          CMP     DH,CH                   ; ten und testen, ob das Ende
          JNZ     @@NextLine              ; erreicht ist.
          CMP     [ToShift],0             ; Befindet sich noch ein Rest
          JZ      @@Ok                    ; der Zeile im zweiten Buffer ?
          CALL    OutBuff                 ; Ebenfalls noch ausgeben.
          JC      @@Exit                  ; Druckerfehler eingetreten ?
  @@Ok:   MOV     ES:[@STATUS_BYTE],0     ; Hardcopy erfolgreich beendet.
  @@Exit: POP     DX                      ; Alte Cursorposition zurck-
          MOV     AH,02H                  ; holen und den Cursor neu
          INT     10H                     ; setzen.
  @@Bye:  Cmd     POP,<BP,DI,SI,DX,CX,BX,AX,ES,DS>
          IRET                            ; Tschss...
  PrtScr ENDP
  ;
  ; Ein einzelnes Zeichen in den Zeilenbuffer aufnehmen (Attribut wird
  ; bercksichtigt).
  ;
  InsertChar PROC NEAR
          Cmd     PUSH,<ES,DX,CX,BX>      ; Register retten
          PUSH    AX                      ; Attribut retten
          XOR     AH,AH                   ; Da die einzelnen Zeichen im
          ADD     AX,AX                   ; ROM 14 Zeilen hoch sind, mu
          MOV     BX,AX                   ; der Zeichencode mit 14 multi-
          ADD     AX,AX                   ; pliziert werden, um den Offset
          ADD     BX,AX                   ; zum Zeichencodebeginn zu
          ADD     AX,AX                   ; berechnen.
          ADD     AX,BX
          ADD     AX,WORD PTR [CharPtr]   ; Zeiger auf den Zeichensatz im
          MOV     ES,WORD PTR [CharPtr+2] ; EGA/VGA-BIOS-ROM
          MOV     SI,AX
  ;
  ; Aus dem ROM-Zeichen nun das Bitmuster im Format 16*28 erzeugen.
  ;
          MOV     DI,OFFSET CharBuff      ; ^ auf Buffer fr das Zeichen
          MOV     DL,8                    ; Zeichen ist 8 Spalten breit
          ADD     SI,13                   ; ...wird rckwrts ausgelesen
          MOV     CL,1                    ; Zuerst 1. Spalte auslesen
  @@Col:  PUSH    SI                      ; ^ auf Zeichen retten
          MOV     DH,14                   ; Zeichen ist 14 Zeilen hoch
          XOR     BX,BX                   ; Die Spalten initialisieren
  @@Row:  MOV     CH,ES:[SI]              ; die Bits einer einzelnen
          DEC     SI                      ; Spalte des aktuellen Zeichens
          SHL     CH,CL                   ; nun einsammeln und im Buffer
          RCR     BX,1                    ; ablegen.
          RCR     AX,1
          MOV     CH,BH                   ; Das oberste Bit aus BH noch
          SHL     CH,1                    ; einmal in den 32-Bit-Wert in
          RCR     BX,1                    ; AX:BX "einschieben" (ent-
          RCR     AX,1                    ; spricht Vergrerung auf 200%)
          DEC     DH                      ; Spalten-Bit der nchsten Zeile
          JNZ     @@Row                   ; bearbeiten
          INC     CL                      ; Spter eine Spalte weiter
          Store   0                       ; Zeile im Zwischenbuff. ablegen
          NOT     BX                      ; Die Maske fr den Hintergrund
          NOT     AX                      ; wird ebenfalls bentigt.
          AND     AL,0F0H                 ; Es werden nur 28 Bits bentigt
          Store   64                      ; Auch die Maske ablegen
          ADD     DI,8                    ; Nchste Spalte im Buffer
          POP     SI                      ; ^ auf Zeichen wiederherstellen
          DEC     DL                      ; und die nchste Spalte be-
          JNZ     @@Col                   ; arbeiten
  ;
  ; Anhand der Farbe fr Vorder- und Hintergrund nun die beiden Bitmuster
  ; des Zeichens anpassen
  ;
          POP     BX                      ; Attribut zurckholen
          MOV     BL,BH
          PUSH    BX
          AND     BX,000FH                ; Nur die Vordergrundfarbe nun
          ADD     BX,BX                   ; benutzen, um die entsprechende
          MOV     SI,[InkMask+BX]         ; Mustermaske zu ermitteln.
          MOV     DI,OFFSET CharBuff
          CALL    DitherIt
          POP     BX                      ; die Hintergrundfarbe ebenfalls
          MOV     CL,4                    ; fr das Hintergrundmuster
          SHR     BX,CL                   ; benutzen.
          AND     BX,0007H                ; Flash-Bit "fliegt heraus"
          ADD     BX,BX
          MOV     SI,[PaperMask+BX]
          CALL    DitherIt
  ;
  ; Kopieren des fertigen Zeichens in den Zeilenbuffer
  ;
          MOV     BX,OFFSET CharBuff      ; ^ auf Zeichen & Hintergrund
          MOV     SI,[BuffPtr]            ; Der obere Teil wird zum Druk-
                                          ; ker gesendet, der Rest in den
          MOV     [Counter],16            ; Buffer. 16 Spalten sind zu
  @@Loop:                                 ; kopieren.
          ReptC   MOV,0                   ; Eine Spalte "Zeichen" und
          ReptC   OR,64                   ; Maske zusammenlegen
          ADD     BX,4                    ; (eine Spalte weiter)
          XOR     DX,DX                   ; AX:CX:DX = Schieberegister
          MOV     BP,[ToShift]            ; Anz. zu verschiebender Reihen
          OR      BP,BP                   ; Falls nichts zu verschieben
          JZ      @@ToBuff                ; ist, sofort ablegen.
  @@Shift:
          SHR     AH,1                    ; Die Daten im "Schieberegister"
          IRP     Reg,<AL,CH,CL,DH,DL>    ; jeweils um ein Bit nach rechts
          RCR     Reg,1                   ; (= unten) verschieben.
          ENDM
          DEC     BP                      ; um wieviele Bits verschieben ?
          JNZ     @@Shift
  @@ToBuff:
          OR      [SI],AH                 ; Das "Ergebnis" wird nun in den
          OR      [SI+1],AL               ; beiden Buffern abgelegt. Die
          OR      [SI+2],CH               ; Daten der aktuellen Zeile kom-
          Cmd     PUSH,<SI,CX,DX>         ; men direkt in den Buffer des
          MOV     CX,3                    ; Druckers, so da der Speicher-
          CALL    OutStr                  ; platz fr einen 2. Buffer ein-
          Cmd     POP,<DX,CX,SI>          ; gespart werden kann.
          JC      @@Exit
          MOV     [SI],CL
          MOV     [SI+1],DH
          MOV     [SI+2],DL
          ADD     SI,3
          DEC     [Counter]               ; Die nchste Spalte bearbeiten
          JNZ     @@Loop
          MOV     [BuffPtr],SI            ; aktuelle Position in beiden
          CLC                             ; Buffern zwischenspeichern. Ok.
  @@Exit: Cmd     POP,<BX,CX,DX,ES>
          RET
  InsertChar ENDP
  ;
  ; Das Zeichen bzw. den Hintergrund durch Dithering in unterschiedliche
  ; Graustufen umformen.
  ;
  DitherIt PROC NEAR
          CLD                             ; Den Zeichenbuffer (Zeichen
          MOV     CX,64                   ; bzw. Hintergrund) nun mit der
  @@Loop: LODSB                           ;  Maske verunden
          AND     [DI],AL
          INC     DI
          LOOP    @@Loop                  ; rumdiadums...
          RET                             ; ...fertig.
  DitherIt ENDP
  ;
  ; Den Buffer an den Drucker ausgeben
  ;
  OutBuff PROC NEAR
          MOV     CX,9                    ; Den Drucker in den Grafikmodus
          MOV     SI,OFFSET GraphOn       ; (24 Nadeln, 180 Punkte/Zoll)
          CALL    OutStr                  ; umschalten.
          JC      @@Exit                  ; Druckerfehler eingetreten ?
          MOV     SI,OFFSET Buff
          MOV     CX,PixelH*3             ; Lnge des Buffers, die Pixel-
          CALL    OutStr                  ; daten ausgeben.
          JC      @@Exit                  ; Druckerfehler eingetreten ?
          MOV     SI,OFFSET CrLf
          MOV     CX,2                    ; Noch einen Zeilenvorschub
          CALL    OutStr                  ; ausgeben.
  @@Exit: RET
  OutBuff ENDP

  OutStr PROC NEAR
          XOR     DX,DX                   ; Zeile an LPT1: ausgeben
          CLD
  @@Loop: MOV     AH,00
          LODSB                           ; Datenbyte lesen...
          INT     17H                     ; ... und ausgeben.
          TEST    AH,29H                  ; Wenn Papierende, I/O-Fehler
          JNZ     @@CleanUp               ; oder Time-Out, dann PrtScr
          LOOP    @@Loop                  ; beenden.
          CLC                             ; Operation erfolgreich ver-
          RET                             ; laufen.
  @@CleanUp:
          MOV     AX,0040H                ; BIOS-Datensegment adressieren
          MOV     ES,AX
          MOV     ES:[@STATUS_BYTE],0FFH  ; "Hardcopy konnte nicht beendet
          STC                             ; werden". Via C-Flag einen
          RET                             ; Fehler melden.
  OutStr ENDP

  ClearBuffer PROC NEAR
          PUSH    ES
          MOV     DI,OFFSET Buff          ; Der Buffer mu jeweils von
          MOV     [BuffPtr],DI            ; Zeit zu Zeit gelscht werden.
          CLD
          MOV     CX,PixelH*3             ; Jede Spalte ist drei Bytes
          MOV     AX,DS                   ; "hoch".
          MOV     ES,AX
          XOR     AL,AL                   ; Mit Nullen fllen
          REP     STOSB
          POP     ES
          RET
  ClearBuffer ENDP
  ;
  ; Tabellen mit der bersetzung Farbe --> Muster
  ;
  InkMask         DW      Mask0           ; Schwarz
                  DW      Mask6@25        ; (Dunkel-) Blau
                  DW      Mask12@5        ; (Dunkel-) Grn
                  DW      Mask25          ; (Dunkel-) Cyan
                  DW      Mask6@25        ; (Dunkel-) Rot
                  DW      Mask12@5        ; (Dunkel-) Lila
                  DW      Mask25          ; (Dunkel-) Gelb
                  DW      Mask50          ; (Dunkel-) Wei
                  DW      Mask0           ; (Hell-) Schwarz (??)
                  DW      Mask25          ; Blau
                  DW      Mask60          ; Grn
                  DW      Mask75          ; Cyan
                  DW      Mask50          ; Rot
                  DW      Mask56          ; Lila
                  DW      Mask100         ; Gelb (eigentlich Mask75)
                  DW      Mask100         ; Wei

  PaperMask       DW      Mask0           ; Schwarz
                  DW      Mask0           ; Blau (eigentlich Mask6@25)
                  DW      Mask50          ; Grn
                  DW      Mask60          ; Cyan
                  DW      Mask12@5        ; Rot
                  DW      Mask25          ; Lila
                  DW      Mask75          ; Gelb
                  DW      Mask100         ; Wei
  ;
  ; Die Variablen des Programms
  ;
  Buff            DB      PixelH*3 DUP (0); Buffer fr restliche Zeilen
  BuffPtr         DW      OFFSET Buff     ; Zeiger in den Buffer

  CharBuff        DB      64 DUP (0)      ; zu bearbeitendes Zeichen
                  DB      64 DUP (0)      ; inkl. der Maske

  CharPtr         DD      ?               ; Zeiger auf Zeichensatz im ROM
  ToShift         DW      0
  Counter         DW      ?               ; Hilfszhler
  OldINT5         DD      ?               ; Adresse alte PrtScr-Routine

  Mask0    DB  64 DUP (0)                 ; ... rabenschwarz
  Mask6@25 DB  2 DUP (4 DUP (088H),12 DUP (0),4 DUP (022H),12 DUP (0))
  Mask12@5 DB  4 DUP (4 DUP (088H),4 DUP (0),4 DUP (022H),4 DUP (0))
  Mask25   DB  4 DUP (4 DUP (0AAH),4 DUP (0),4 DUP (055H),4 DUP (0))
  Mask50   DB  8 DUP (4 DUP (0AAH),4 DUP (055H))
  Mask56   DB  4 DUP (4 DUP (0AAH),4 DUP (077H),4 DUP (0AAH),4 DUP (055H))
  Mask60   DB  4 DUP (4 DUP (0AAH),4 DUP (077H),4 DUP (0AAH),4 DUP (0DDH))
  Mask75   DB  8 DUP (4 DUP (0AAH),4 DUP (0FFH))
  Mask100  DB  64 DUP (0FFH)

  CrLf            DB      0DH,0AH
  GraphOn         DB      4 DUP (' '),27,'*',39,PixelH MOD 256,PixelH/256
  ShortFeed       DB      0DH,0AH,27,'A',8; Papier zustzlich spannen
  NormalFeed      DB      27,'2'
  ;
  ; Hier beginnt der Installationscode und endet zugleich der residente
  ; Teil des Programms
  ;
          ASSUME  DS:CODE,ES:NOTHING
  INSTALL PROC NEAR
          PUSH    CS                      ; Wie immer, erst einmal DS ein-
          POP     DS                      ; richten und eine kleine und
          MOV     AH,9                    ; dezente Meldung unauffllig
          MOV     DX,OFFSET MSG1          ; auf dem Bildschirm plazieren.
          INT     21H
          MOV     AX,1130H                ; Den Zeiger auf den ROM-
          MOV     BH,2                    ; Zeichensatz (8*14) lesen und
          INT     10H                     ; abspeichern.
          MOV     WORD PTR [CharPtr],BP
          MOV     WORD PTR [CharPtr+2],ES
          MOV     AX,3505H                ; Den alten Interruptvektor fr
          INT     21H                     ; PrtScr fr sptere Zeiten ab-
          MOV     WORD PTR [OldINT5],BX   ; speichern.
          MOV     WORD PTR [OldINT5+2],ES
          MOV     AX,2505H                ; Den neuen PrtScr-Interrupt
          MOV     DX,OFFSET PRTSCR        ; einhngen.
          INT     21H
          MOV     DX,OFFSET INSTALL       ; Den Rest des Programms (ohne
          INT     27H                     ; Installationsteil) resident
                                          ; verankern.

  MSG1    DB      'Harrys NEC-P6/P7-PrtScr fr Textbildschirme (EGA/VGA) '
          DB      'Version 1.2  C''t 04/90 S.258',0DH,0AH
          DB      'Harald Albrecht 12/''89',0DH,0AH,'$'

  INSTALL ENDP

  CODE    ENDS
          END     START
