;==============================================================================
;
; RAM-Statusbericht V0.0
; 04.08.1991 Sven B. Schreiber
; Public Domain
;
;------------------------------------------------------------------------------
;
code	segment
	assume	cs:code,ds:code,es:code,ss:code
;
;------------------------------------------------------------------------------
;
base		equ	0100h		;programm-startadresse
;
mem		equ	12h		;basisspeichergre abfragen
sys		equ	15h		;systemservice
dos		equ	21h		;dos-bibliothek
mpx		equ	2fh		;multiplexer
emm		equ	67h		;expanded memory manager
;
character	equ	02h		;zeichen anzeigen
text		equ	09h		;text anzeigen
terminate	equ	4ch		;programm beenden
;
lf		equ	0ah		;line feed
cr		equ	0dh		;carriage return
;
;==============================================================================
;
	org	base
start:
	jmp	main
	dw	freemem
;
	DB	'           '
	DB	'Public Domain   '
	DB	'================'
	DB	'RAMSTAT   -  0.0'
	DB	'04.08.91  -  SBS'
	DB	'================'
	DB	'S. B. Schreiber '
	DB	'                '
;
;==============================================================================
;
;				 hauptprogramm
;
;------------------------------------------------------------------------------
;
main:
	call	prepare				;parameter vorbereiten
	call	report				;status anzeigen
	mov	al,0				;programm beenden
	mov	ah,terminate
	int	dos
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
prepare:
	call	xmsstatus			;xms-status abfragen
	call	emsstatus			;ems-status abfragen
	call	a20test				;a20-zustand testen
	jz	prepare1
	mov	word ptr a20on?,1		;a20 eingeschaltet
prepare1:
	int	mem				;basisspeichergre laden
	mov	word ptr basememory,ax
	mov	ah,88h				;int-15h-freispeicher abfragen
	int	sys
	mov	word ptr int15free,ax
	mov	ax,es				;extrasegmentadresse berechnen
	mov	dl,0
	shl	ax,1
	rcl	dl,1
	shl	ax,1
	rcl	dl,1
	shl	ax,1
	rcl	dl,1
	shl	ax,1
	rcl	dl,1
	add	word ptr target,ax		;codesegment plus pufferadresse
	adc	byte ptr target+2,dl
	mov	ah,87h				;vdisk-id laden
	mov	si,offset vdiskgdt
	mov	cx,offset ?buffer/2
	int	sys
	mov	si,offset buffer		;vdisk geladen?
	mov	di,offset vdiskid
	mov	cx,offset ?vdiskid
	cld
	repz	cmpsb
	jnz	prepare2
	mov	word ptr vdisk?,1		;vdisk geladen
prepare2:
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
xmsstatus:
	mov	ax,offset 4300h			;xms-treiber installiert?
	int	mpx
	cmp	al,80h
	jz	xmsstatus1
	ret
xmsstatus1:
	mov	word ptr xmsdriver?,1		;xms-treiber installiert
	push	es
	mov	ax,offset 4310h			;adresse des xms-api laden
	int	mpx
	mov	word ptr xmsapi,bx		;adresse des xms-api merken
	mov	word ptr xmsapi+2,es
	pop	es
	mov	ah,0				;xms-versionsnummer abfragen
	call	dword ptr xmsapi
	mov	word ptr xmsversion,ax		;xms-versionsnummer merken
	mov	word ptr xmsrevision,bx		;interne revisionsnummer merken
	mov	word ptr hma?,dx		;hma-status merken
	mov	ah,8				;freispeicher abfragen
	call	dword ptr xmsapi
	test	bl,80h				;fehler?
	jnz	xmsstatus2
	mov	word ptr xmsfree,dx		;freies xms merken
	mov	word ptr xmsblock,ax		;grten xms-block merken
xmsstatus2:
	mov	ah,1				;hma reservieren
	mov	dx,-1
	call	dword ptr xmsapi
	test	bl,80h				;fehler?
	jnz	xmsstatus3
	cmp	ax,1				;erfolgreich?
	jnz	xmsstatus3
	mov	word ptr hmafree?,1		;hma reserviert
xmsstatus3:
	mov	ah,2				;hma freigeben
	call	dword ptr xmsapi
	call	a20test				;a20-zustand testen
	pushf
	mov	ah,5				;a20-zustand wechseln
	jz	xmsstatus4
	mov	ah,6
xmsstatus4:
	call	dword ptr xmsapi
	call	a20test				;a20-zustand testen
	mov	cx,0
	jz	xmsstatus5
	mov	cx,1
xmsstatus5:
	popf
	mov	ah,6				;a20-zustand nochmals wechseln
	mov	bx,0
	jz	xmsstatus6
	mov	ah,5
	mov	bx,1
xmsstatus6:
	push	bx
	push	cx
	call	dword ptr xmsapi
	call	a20test				;a20-zustand testen
	pop	cx
	pop	bx
	mov	dx,0
	jz	xmsstatus7
	mov	dx,1
xmsstatus7:
	xor	bx,cx				;alle zustandswechsel ok?
	xor	dx,cx
	and	bx,dx
	jz	xmsstatus8
	mov	word ptr a20ok?,1		;a20 umschaltbar
xmsstatus8:
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
emsstatus:
	push	ds
	mov	si,0				;emm-interruptvektor testen
	mov	ds,si
	mov	si,offset emm*4
	mov	ax,word ptr [si]		;serviceroutine installiert?
	or	ax,word ptr [si+2]
	pop	ds
	jnz	emsstatus1
	ret
emsstatus1:
	mov	ah,46h				;ems-versionsnummer abfragen
	int	emm
	cmp	ah,0				;ok?
	jz	emsstatus2
	ret
emsstatus2:
	mov	word ptr emsdriver?,1		;ems-treiber installiert
	mov	ah,al				;versionsnummer standardisieren
	mov	cl,4
	shr	ah,cl
	and	ax,0f0fh
	mov	word ptr emsversion,ax		;versionsnummer merken
	mov	ah,41h				;seitenfensteradresse abfragen
	int	emm
	cmp	ah,0				;ok?
	jnz	emsstatus3
	mov	word ptr emspageframe,bx	;seitenfensteradresse merken
emsstatus3:
	mov	ah,42h				;anzahl der seiten abfragen
	int	emm
	cmp	ah,0				;ok?
	jnz	emsstatus4
	mov	word ptr emsfree,bx		;anzahl freier seiten merken
	mov	word ptr emstotal,dx		;gesamtzahl der seiten merken
emsstatus4:
	mov	ah,4ch				;anz. interner seiten abfragen
	mov	dx,0
	int	emm
	cmp	ah,0				;ok?
	jnz	emsstatus5
	mov	word ptr emsinternal,bx		;anz. interner seiten merken
emsstatus5:
	mov	ah,4bh				;anzahl der handles abfragen
	int	emm
	cmp	ah,0				;ok?
	jnz	emsstatus6
	mov	word ptr emshandles,bx		;anzahl der handles merken
emsstatus6:
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
report:
	mov	si,offset $status		;1. teil anzeigen
	mov	di,offset $table
	call	display
	cmp	word ptr emsdriver?,0		;ems-status nur wenn treiber da
	jz	report1
	call	display				;2. teil anzeigen
report1:
	mov	si,offset $status1		;3. teil anzeigen
	mov	di,offset $table1
	call	display
	cmp	word ptr xmsdriver?,0		;xms-status nur wenn treiber da
	jz	report2
	call	display				;4. teil anzeigen
report2:
	mov	si,offset $status2		;5. teil anzeigen
	mov	di,offset $table2
	jmp	display
;
;==============================================================================
;
;	<	z  -  gesetzt falls a20 ausgeschaltet
;
;------------------------------------------------------------------------------
;
a20test:
	push	ds
	push	es
	mov	si,00000h			;low-memory-testadresse
	mov	ax,00000h
	mov	ds,ax
	mov	di,00010h			;high-memory-testadresse
	mov	ax,0ffffh
	mov	es,ax
	mov	cx,0fff0h/2			;speicherbereich gespiegelt?
	cld
	repz	cmpsw
	pop	es
	pop	ds
	ret
;
;==============================================================================
;
;	>	si  -  textadresse
;		di  -  tabellenadresse
;
;	<	si  -  nchste textadresse
;		di  -  nchste tabellenadresse
;
;------------------------------------------------------------------------------
;
display:
	push	di
	call	message				;text anzeigen
	pop	di
	mov	bx,word ptr [di]		;variable laden
	add	di,2
	cmp	bx,0				;tabellenende?
	jnz	display1
	ret
display1:
	push	si
	push	di
	mov	ax,word ptr [bx]		;parameter laden
	call	word ptr [di]			;anzeigeroutine ausfhren
	pop	di
	pop	si
	add	di,2				;nchste variable
	jmp	display
;
;==============================================================================
;
;	>	si  -  textadresse
;
;	<	si  -  nchste textadresse
;		cx  -  lnge des parameterfelds
;
;------------------------------------------------------------------------------
;
message:
	cmp	byte ptr [si],'$'		;textende
	jnz	message1
	jmp	skip
message1:
	cld					;zeichen laden
	lodsb
	push	si
	mov	dl,al				;zeichen anzeigen
	mov	ah,character
	int	dos
	pop	si
	jmp	message
;
;==============================================================================
;
;	>	si  -  textadresse
;
;	<	si  -  nchste textadresse
;		cx  -  anzahl bersprungener zeichen
;
;------------------------------------------------------------------------------
;
skip:
	mov	cx,0				;zeichenzhler laden
skip1:
	cmp	byte ptr [si],'$'		;textende?
	jz	skip2
	ret
skip2:
	inc	si				;textendezeichen berspringen
	inc	cx
	jmp	skip1
;
;==============================================================================
;
;	>	ax  -  16-bit-zahl
;
;------------------------------------------------------------------------------
;
dispdec:
	mov	bh,16				;bitzhler laden
	mov	cl,0				;zielregister lschen
	mov	dx,0
	mov	bp,ax
dispdec1:
	shl	bp,1				;msb --> carry
	mov	al,dl				;1. und 2. stelle berechnen
	adc	al,al
	daa
	mov	dl,al
	mov	al,dh				;3. und 4. stelle berechnen
	adc	al,al
	daa
	mov	dh,al
	mov	al,cl				;5. stelle berechnen
	adc	al,al
	daa
	mov	cl,al
	dec	bh
	jnz	dispdec1			;nchstes bit
	shl	dx,1				;um eine stelle nach links
	rcl	cl,1
	shl	dx,1
	rcl	cl,1
	shl	dx,1
	rcl	cl,1
	shl	dx,1
	rcl	cl,1
	mov	si,0				;fhrende nullen unterdrcken
	mov	bh,5				;nybble-zhler laden
dispdec2:
	mov	ah,4				;bitzhler laden
dispdec3:
	shl	dx,1				;nchstes nybble laden
	rcl	cl,1
	rcl	al,1
	dec	ah
	jnz	dispdec3
	and	ax,000fh
	or	si,ax
	jnz	dispdec4			;keine fhrende null
	cmp	bh,1
	jz	dispdec4			;letzte ziffer
	mov	al,' '-'0'			;fhrende null ersetzen
dispdec4:
	push	si
	push	bx
	push	cx
	push	dx
	add	al,'0'				;ascii-ziffer anzeigen
	mov	dl,al
	mov	ah,character
	int	dos
	pop	dx
	pop	cx
	pop	bx
	pop	si
	dec	bh
	jnz	dispdec2			;nchstes nybble
	ret
;
;==============================================================================
;
;	>	ax  -  16-bit-zahl
;
;------------------------------------------------------------------------------
;
dispword:
	push	ax
	mov	al,ah				;oberes byte anzeigen
	call	dispbyte
	pop	ax				;unteres byte anzeigen
	jmp	dispbyte
;
;==============================================================================
;
;	>	al  -  8-bit-zahl
;
;------------------------------------------------------------------------------
;
dispbyte:
	push	ax
	mov	cl,4				;oberes halbbyte anzeigen
	shr	al,cl
	call	dispnybble
	pop	ax				;unteres halbbyte anzeigen
	and	al,00001111b
	jmp	dispnybble
;
;==============================================================================
;
;	>	al  -  4-bit-zahl
;
;------------------------------------------------------------------------------
;
dispnybble:
	and	al,00001111b			;umwandlung in ascii
	add	al,'0'
	cmp	al,'9'
	jna	dispnybble1
	add	al,'A'-'0'-10
dispnybble1:
	mov	dl,al				;zeichen anzeigen
	mov	ah,character
	int	dos
	ret
;
;==============================================================================
;
;	>	al  -  8-bit-zahl
;
;------------------------------------------------------------------------------
;
dispnumber:
	push	ax
	mov	cl,4				;oberes halbbyte anzeigen
	shr	al,cl
	test	al,00001111b			;fhrende null?
	mov	bp,offset dispnumber2
	jnz	dispnumber1
	mov	al,' '				;ersatzdarstellung fr null
	mov	bp,offset dispnumber3
dispnumber1:
	call	bp
	pop	ax				;unteres halbbyte anzeigen
dispnumber2:
	and	al,00001111b			;umwandlung in ascii
	add	al,'0'
	cmp	al,'9'
	jna	dispnumber3
	add	al,'A'-'0'-10
dispnumber3:
	mov	dl,al				;zeichen anzeigen
	mov	ah,character
	int	dos
	ret
;
;==============================================================================
;
;	>	ax  -  flag (0 = nein, 1 = ja)
;
;------------------------------------------------------------------------------
;
dispyesno:
	cmp	ax,0				;flag testen
	mov	si,offset $no			;nein
	jz	dispyesno1
	mov	si,offset $yes			;ja
dispyesno1:
	jmp	message
;
;==============================================================================
;
;				bildschirmtexte
;
;------------------------------------------------------------------------------
;
$table:
	dw	basememory,	dispdec
	dw	int15free,	dispdec
	dw	vdisk?,		dispyesno
	dw	emsdriver?,	dispyesno
	dw	0
	dw	emsversion+1,	dispnybble
	dw	emsversion,	dispnybble
	dw	emspageframe,	dispword
	dw	emstotal,	dispdec
	dw	emsfree,	dispdec
	dw	emsinternal,	dispdec
	dw	emshandles,	dispdec
	dw	0
$table1:
	dw	xmsdriver?,	dispyesno
	dw	0
	dw	xmsversion+1,	dispnumber
	dw	xmsversion,	dispbyte
	dw	xmsrevision+1,	dispnumber
	dw	xmsrevision,	dispbyte
	dw	xmsapi+2,	dispword
	dw	xmsapi,		dispword
	dw	xmsfree,	dispdec
	dw	xmsblock,	dispdec
	dw	hma?,		dispyesno
	dw	hmafree?,	dispyesno
	dw	a20ok?,		dispyesno
	dw	0
$table2:
	dw	a20on?,		dispyesno
	dw	0
;
;------------------------------------------------------------------------------
;
$status:
	db	cr,lf,'                             - RAM-Statusbericht -'
	db	cr,lf,'          ͸'
	db	cr,lf,'             Beim Selbsttest erkannter Basisspeicher       $$$$$K  '
	db	cr,lf,'             ber den INT 15h ansprechbarer Speicher       $$$$$K  '
	db	cr,lf,'               VDISK im Extended Memory installiert?         $$$$  '
	db	cr,lf,'                            EMS-Treiber installiert?         $$$$  $'
	db	cr,lf,'                            Version des EMS-Treibers          $.$  '
	db	cr,lf,'               Seitenfensteradresse des EMS-Treibers    $$$$:0000  '
	db	cr,lf,'               Insgesamt vorhandene EMS-Seiten  16K        $$$$$  '
	db	cr,lf,'                      Anzahl freier EMS-Seiten  16K        $$$$$  '
	db	cr,lf,'             Anzahl intern belegter EMS-Seiten  16K        $$$$$  '
	db	cr,lf,'             Verfgbare Verwaltungsnummern (Handles)        $$$$$  $'
$status1:
	db	cr,lf,'                            XMS-Treiber installiert?         $$$$  $'
	db	cr,lf,'                            Version des XMS-Treibers        $$.$$  '
	db	cr,lf,'            Interne Revisionsnummer des XMS-Treibers        $$.$$  '
	db	cr,lf,'                        API-Adresse des XMS-Treibers    $$$$:$$$$  '
	db	cr,lf,'                       Freier XMS-Speicher insgesamt       $$$$$K  '
	db	cr,lf,'                    Grter freier XMS-Speicherblock       $$$$$K  '
	db	cr,lf,'                   High Memory Area (HMA) vorhanden?         $$$$  '
	db	cr,lf,'                   High Memory Area (HMA) verfgbar?         $$$$  '
	db	cr,lf,'                       Adreleitung A20 umschaltbar?         $$$$  $'
$status2:
	db	cr,lf,'                     Adreleitung A20 eingeschaltet?         $$$$  '
	db	cr,lf,'          [SBS];'
	db	cr,lf,'$'
$yes:
	db	'  ja$'
$no:
	db	'nein$'
;
;==============================================================================
;
;		   globale deskriptorentabelle fr vdisk-id
;
;------------------------------------------------------------------------------
;
?vdiskid	equ	5		;lnge der vdisk-identifikation
?buffer		equ	6		;pufferlnge (immer gerade zahl)
;
vdiskid:
	db	'VDISK'			;vdisk-identifikation
buffer:
	db	?buffer dup (0)		;datenpuffer
vdiskgdt:
	db	8 dup (0)		;dummy-deskriptor
	db	8 dup (0)		;gdt-deskriptor
	dw	?buffer			;quell-deskriptor
	dw	0003h
	db	10h
	db	93h
	dw	0
	dw	?buffer			;ziel-deskriptor
target:
	dw	buffer
	db	00h
	db	93h
	dw	0
	db	8 dup (0)		;bios-code-deskriptor
	db	8 dup (0)		;stack-deskriptor
;
;==============================================================================
;
;				   variablen
;
;------------------------------------------------------------------------------
;
vdisk?:
	dw	0			;vdisk geladen?
hma?:
	dw	0			;hma vorhanden?
hmafree?:
	dw	0			;hma verfgbar?
a20ok?:
	dw	0			;adreleitung a20 umschaltbar?
a20on?:
	dw	0			;adreleitung a20 eingeschaltet?
xmsdriver?:
	dw	0			;xms-treiber installiert?
xmsapi:
	dd	0			;adresse des xms-api
xmsversion:
	dw	0			;xms-versionsnummer
xmsrevision:
	dw	0			;interne xms-revisionsnummer
xmsblock:
	dw	0			;grter freier xms-block
xmsfree:
	dw	0			;xms-freispeicher
emsdriver?:
	dw	0			;ems-treiber installiert?
emsversion:
	dw	0			;ems-versionsnummer
emspageframe:
	dw	0			;ems-seitenfensteradresse
emstotal:
	dw	0			;anzahl der ems-seiten
emsfree:
	dw	0			;anzahl der freien ems-seiten
emsinternal:
	dw	0			;anzahl der intern belegten ems-seiten
emshandles:
	dw	0			;anzahl der handles
int15free:
	dw	0			;int-15h-freispeicher
basememory:
	dw	0			;basisspeichergre
freemem:
;
;------------------------------------------------------------------------------
;
code	ends
	end	start
