; Programmname: PAINTJET.ASM
; (C) 1989 Everts & Hagedorn
;          DOS International

Code Segment
    Assume CS:Code,DS:Code

;Kennung fr Laderoutine
    DB "PRN0"

;Schnittstellen-Wort (COM1:9600,N,8,1,DTR)
    DW 1001010010100010b

;Modus-Wort (Farbe,8x8-Matrix)
    DW 1011100000000000b

;Maximale Gre einer Hardcopy in Dots
    DW 1440
    DW 1080

;Adressen von Beschreibung und Programm
    DW Text,Print,Ende

;Wirkliche Gre der Hardcopy in Dots
MaxX DW ?
MaxY DW ?

;Routine druckt Zeichen in AL
PrintChr DD ?

;Routine druckt String in DS:SI
PrintStr DD ?

;Routine holt Farbe des Pixels in SI/DI
GetPixel DD ?

;Routine prft auf Ctrl-Break
CheckBrk DD ?

;------------------------------------------

;Beschreibung (Maximal 60 Zeichen)
Text DB "Hewlett Packard PaintJet, "
     DB "180 x 180 dpi Farbdruck",0

;------------------------------------------

;Sequenz zum Einschalten des Grafikmodus
Graphic DB 19,13,10,27,"*t180R",27,"*r3U"
        DB 27,"*r0A"
;Sequenz zum bertragen der Farbebenen 1&2
Ebene   DB 7,27,"*b180V"
;Sequenz zur bertragung der letzten Ebene
Letzte  DB 7,27,"*b180W"
;Sequenz zum Abschalten des Grafikmodus
Fertig  DB 10,27,"*r0B",13,10,10,10,10

;Deklaration der Puffer
Grn Equ Byte Ptr Schluss
Blu Equ Byte Ptr Schluss+180

Print Proc Far
;Drucker in Grafikmodus schalten
    Mov SI,Offset Graphic
    Call PrintStr
;Zeilenzhler zurcksetzen
    Xor DI,DI
Zeile:
;Empfang der 1. Ebene (Rot) vorbereiten
    Mov SI,Offset Ebene
    Call PrintStr
;Spaltenzhler zurcksetzen
    Xor SI,SI
;Bytezhler zurcksetzen
    Mov BX,SI
Spalte:
;8 Bits ergeben 1 Byte
    Mov CX,8
Bit:
    Push BX
;Farbwerte nach AL/AH/BL holen
    Call GetPixel
;Farben in die Puffer schreiben
    Shl BL,1
    Pop BX
    Rcl [Blu+BX],1
    Shl AH,1
    Rcl [Grn+BX],1
;Aus Performance-Grnden wird die 1. Ebene
;gleich ausgegeben, das erfolgt parallel
;zur Fllung der Puffer
    Shl AL,1
    Rcl DL,1
;Spaltenzhler erhhen
    Inc SI
    Loop Bit
;Rot-Anteil gleich ausgeben
    Mov AL,DL
    Call PrintChr
;Bytezhler erhhen
    Inc BX
;Solange weitermachen, bis der rechte Rand
;erreicht ist
    Cmp SI,MaxX
    Jb Spalte
;Bei der Einstellung "nchstkleinere Bild-
;gre" mu u.U. bis auf 180 Bytes aufge-
;fllt werden (mit Farbe Wei)
    Mov AL,255
Fuellen:
    Cmp BL,180
    Jae FuellOk
;Fr die Rot-Ebene direkt ausgeben
    Call PrintChr
;Fr Grn und Blau in den Puffer schreiben
    Mov [Grn+BX],AL
    Mov [Blu+BX],AL
    Inc BX
    Jmp Fuellen
FuellOk:
;Jetzt knnen die Werte im Puffer ausge-
;geben werden, zuerst die Grn-Ebene
    Mov SI,Offset Ebene
    Call PrintStr
    Mov SI,Offset Grn
WriteGrn:
    Lodsb
    Call PrintChr
    Cmp SI,Offset Grn+180
    Jb WriteGrn
;Und zum Schlu die Blau-Ebene
    Mov SI,Offset Letzte
    Call PrintStr
    Mov SI,Offset Blu
WriteBlu:
    Lodsb
    Call PrintChr
    Cmp SI,Offset Blu+180
    Jb WriteBlu
;Auf Ctrl-Break prfen
    Call CheckBrk
    Jc Raus
;Zeilenzhler erhhen
    Inc DI
;Solange weitermachen, bis die letzte Zeile
;ausgegeben wurde
    Cmp DI,MaxY
    Jae Raus
    Jmp Zeile
Raus:
;Grafikmodus wieder ausschalten
    Mov SI,Offset Fertig
    Call PrintStr
    Ret
Print Endp

Schluss Label Byte
;Hier werden 2*180 Bytes fr die Puffer
;reserviert
Ende = Schluss+360

Code Ends
    End
