{$R-,S-,I-,D-,F-,V-,B-,M 8192,0,0}
Uses
  Crt, Dos;

Var
  GrafikFlag: Boolean;
  Datei: File Of Byte;
  Bildname: String;
  VideoModus, Wert, Hintergrund, Palette: Byte;
  Reg: Registers;
  Taste: Char;
  Rot, Gruen, Blau: Array [0..255] Of Byte;
  Farben, Max, I: Integer;
  Blinkflag: Boolean;

Procedure Fehler (Meldung: String);
  Begin
    If GrafikFlag Then TextMode (LastMode);
    Writeln ('Fehler: ', Meldung);
    Halt (1)
  End;

Procedure SetzePosition (Position: LongInt);
  Begin
    Seek (Datei, Position - 64);
    If IOResult <> 0 Then Fehler ('Datei kann nicht gelesen werden')
  End;

Procedure ZeigeBild;
  Begin
    Exec (Bildname, 'C');
    If DosExitCode <> 6 Then Fehler ('Bild kann nicht geladen werden');
    GrafikFlag := True;
    SetzePosition (692)
  End;

Procedure CGA;
  Begin
    ZeigeBild;
    Read (Datei, Hintergrund);
    SetzePosition (699);
    Read (Datei, Palette);
    Palette := (Palette And 1) Or (Hintergrund Shr 3 And 2);
    Repeat
      Hintergrund := (Hintergrund And 15) Or (Palette Shl 3 And 16);
      Reg.AH := $0B;
      Reg.BX := Hintergrund;
      Intr ($10, Reg);
      Reg.AH := $0B;
      Reg.BX := 256 Or (Palette And 1);
      Intr ($10, Reg);
      Taste := ReadKey;
      Case Taste Of
        'h': Inc (Hintergrund);
        'H': Dec (Hintergrund);
        'p': Inc (Palette);
        'P': Dec (Palette);
        #13:
          Begin
            SetzePosition (692);
            Write (Datei, Hintergrund);
            SetzePosition (699);
            Palette := Palette And 1;
            Write (Datei, Palette)
          End
      End
    Until Taste In [#13, #27]
  End;

Procedure HoleTaste;
  Begin
    Taste := ReadKey;
    Blinkflag := Taste In [#0, ' '];
    If Taste = #0 Then
      Case ReadKey Of
        #$4D: Inc (I);
        #$4B: Dec (I);
        #$74: I := I + 8;
        #$73: I := I - 8;
        #$47: I := 0;
        #$4F: I := Max
      End;
    If I > Max Then I := Max;
    If I < 0 Then I := 0;
    If Taste = '0' Then
      Begin
        Rot [I] := 0;
        Gruen [I] := 0;
        Blau [I] := 0
      End;
    If (Taste In ['r', 'm', 'y', 'w']) And (Rot [I] < Farben) Then Inc (Rot [I]);
    If (Taste In ['R', 'M', 'Y', 'W']) And (Rot [I] > 0) Then Dec (Rot [I]);
    If (Taste In ['g', 'y', 'c', 'w']) And (Gruen [I] < Farben) Then Inc (Gruen [I]);
    If (Taste In ['G', 'Y', 'C', 'W']) And (Gruen [I] > 0) Then Dec (Gruen [I]);
    If (Taste In ['b', 'c', 'm', 'w']) And (Blau [I] < Farben) Then Inc (Blau [I]);
    If (Taste In ['B', 'C', 'M', 'W']) And (Blau [I] > 0) Then Dec (Blau [I])
  End;

Procedure EGA;
  Function Farbe: Byte;
    Begin
      Farbe := (Rot [I] Shl 5 And 32) Or (Rot [I] Shl 1 And 4)
        Or (Gruen [I] Shl 4 And 16) Or (Gruen [I] And 2)
        Or (Blau [I] Shl 3 And 8) Or (Blau [I] Shr 1 And 1)
    End;
  Begin
    ZeigeBild;
    For I := 0 To 16 Do
      Begin
        Read (Datei, Wert);
        Rot [I] := (Wert Shr 5 And 1) Or (Wert Shr 1 And 2);
        Gruen [I] := (Wert Shr 4 And 1) Or (Wert And 2);
        Blau [I] := (Wert Shr 3 And 1) Or (Wert Shl 1 And 2)
      End;
    Farben := 3;
    Max := 16;
    I := 0;
    Repeat
      If I < 16 Then Reg.AX := $1000 Else Reg.AX := $1001;
      Reg.BL := I;
      Reg.BH := Farbe;
      Intr ($10, Reg);
      HoleTaste;
      If Blinkflag Then For Wert := 0 To 3 Do
        Begin
          If I < 16 Then Reg.AX := $1000 Else Reg.AX := $1001;
          Reg.BL := I;
          Reg.BH := (Wert And 1) * 63;
          Intr ($10, Reg)
        End
    Until Taste In [#13, #27];
    If Taste = #13 Then
      Begin
        SetzePosition (692);
        For I := 0 To 16 Do
          Begin
            Wert := Farbe;
            Write (Datei, Wert)
          End
      End
  End;

Procedure VGA;
  Begin
    ZeigeBild;
    For I := 0 To 255 Do Read (Datei, Rot [I], Gruen [I], Blau [I]);
    Farben := 63;
    Max := 255;
    I := 0;
    Repeat
      Reg.AX := $1010;
      Reg.BL := I;
      Reg.DH := Rot [I];
      Reg.CH := Gruen [I];
      Reg.CL := Blau [I];
      Intr ($10, Reg);
      HoleTaste;
      If Blinkflag Then For Wert := 0 To 31 Do
        Begin
          Reg.AX := $1010;
          Reg.BX := I;
          Reg.DH := (Wert And 1) * 63;
          Reg.CH := (Wert And 1) * 63;
          Reg.CL := (Wert And 1) * 63;
          Intr ($10, Reg);
          Delay (1)
        End
    Until Taste In [#13, #27];
    If Taste = #13 Then
      Begin
        SetzePosition (692);
        For I := 0 To 255 Do Write (Datei, Rot [I], Gruen [I], Blau [I])
      End
  End;

Begin
  { Version 1.01 }
  GrafikFlag := False;
  If ParamCount <> 1 Then Fehler ('Syntax ist "Palette <Bildname>"');
  If Pos ('.', ParamStr (1)) > 0 Then
    Bildname := ParamStr (1)
  Else
    Bildname := ParamStr (1) + '.EXE';
  Assign (Datei, Bildname);
  Reset (Datei);
  If IOResult <> 0 Then Fehler ('Datei nicht gefunden');
  SetzePosition (679);
  Read (Datei, VideoModus);
  Case VideoModus Of
    $04, $05: CGA;
    $0D, $0E, $10, $12, $37: EGA;
    $13, $2D, $2E: VGA;
    Else Fehler ('Unbekanntes Bildformat')
  End;
  Close (Datei);
  TextMode (LastMode);
  If Taste = #27 Then Writeln ('Abbruch durch Benutzer')
End.


