code segment public
assume cs:code,ds:code
org 0100h

    ;Interrupt 5 (PrtSc) oder 9 (KbdInt)
intnr = 9

begin:
  jmp installieren

    ;Struktur fr jeweils eine Definitionszeile
v struc
  modus db ?
  basis dw ?
  faktor db ?
  laenge dw ?
  text db ?
  routine dw ?
v ends
    ;Lnge der Struktur in Bytes, die MASM-Funktion "Length" mag hier nicht
lengthvideo = 9

    ;Definition der von IBM untersttzten Videomodi auer PCjr
videomodi:
v <00h,0b800h,8,2000,1,cgab> ;40*25
v <01h,0b800h,8,2000,1,cgab> ;40*25
v <02h,0b800h,16,4000,1,cgab> ;80*25
v <03h,0b800h,16,4000,1,cgab> ;80*25
v <04h,0b800h,64,16192,0,cgac> ;320*200*4
v <05h,0b800h,64,16192,0,cgac> ;320*200*4
v <06h,0b800h,64,16192,0,schneider> ;640*200*2
v <07h,0b000h,16,4000,1,hercules> ;80*25
v <0dh,0a000h,32,8000,0,ega> ;320*200*16
v <0eh,0a000h,64,16000,0,ega> ;640*200*16
v <0fh,0a000h,128,28000,0,ega> ;640*350*4
v <10h,0a000h,128,28000,0,ega> ;640*350*16
v <11h,0a000h,0,38400,0,cga> ;640*480*2
v <12h,0a000h,0,38400,0,ega> ;640*480*16
v <13h,0a000h,0,64000,0,vga> ;320*200*256
v <7ch,0b800h,0,32000,1,cga16> ;160*100*16

    ;Definition der Videomodi der EVA/1024
v <18h,0b000h,64,11616,1,cga> ;132*44
v <19h,0b000h,16,6600,1,cga> ;132*25
v <1ah,0b000h,16,7392,1,cga> ;132*27
v <22h,0b800h,64,11616,1,cga> ;132*44
v <23h,0b800h,32,6600,1,cga> ;132*25
v <24h,0b800h,32,7392,1,cga> ;132*27
v <25h,0a000h,0,38400,0,ega> ;640*480*16
v <26h,0b800h,64,9600,1,cga> ;80*60
v <29h,0a000h,0,60000,0,ega> ;800*600*4
v <2ah,0b800h,32,8000,1,cga> ;100*40
v <2dh,0a000h,0,0,0,eva> ;640*350*256
v <2eh,0a000h,0,0,0,eva> ;640*480*256
v <37h,0a000h,0,0,0,ega> ;1024*768*16

    ;Hier knnen Sie eigene Modi einfgen

videoende = $

    ;Blinken ein/aus fr EGA-Textmodi
cgab:
  call vorspann
  mov si,offset blink
  call schreiben
  jmp packen

blink dw blinke-blinka
blinka:
  mov ax,1003h
  mov bl,1
blinken = byte ptr $-1
  int 10h
blinke = $

    ;Einfache Modi ohne Farbpaletten und Bitplanes
cga:
  call vorspann
  jmp packen

    ;CGA-Modi 320*200 in 4 Farben
cgac:
  call vorspann
  mov si,offset cgafarbe
  call schreiben
  jmp packen

cgafarbe dw cgafe-cgaf
cgaf:
    ;Randfarbe setzen
  mov ah,0bh
  mov bx,16
cgarand = byte ptr $-2
  int 10h
    ;Palette setzen
  mov ah,0bh
  mov bx,256
cgapalette = byte ptr $-2
  int 10h
cgafe = $

    ;Prfen ob Schneidermodus 2 oder CGA-Modus 06
schneider:
  push bx
  xor bx,bx
  mov ah,06h
  int 15h
    ;Bei Schneider-Computern enthlt BX nach diesem Interrupt die BIOS-Version
  and bx,bx
  pop bx
  je cga
    ;Die vier Bitplanes des Schneider PC auf Gleichheit prfen
  push bx
  push cx
  push ds
  mov ds,videobasis
    ;Port fr Lesezugriffe
  mov dx,03deh
  xor si,si
  mov cx,8096
pruefewort:
    ;Wert von Seite 0 lesen
  mov al,0
  out dx,al
  mov bx,ds:[si]
    ;Mit Seite 1 vergleichen
  inc al
  out dx,al
  cmp ds:[si],bx
    ;Ungleich => Schneidermodus 2
  jne schneidermodus
    ;Mit Seite 2 vergleichen
  inc al
  out dx,al
  cmp ds:[si],bx
  jne schneidermodus
    ;Seite 3
  inc al
  out dx,al
  lodsw
  cmp ax,bx
  loope pruefewort
schneidermodus:
  pop ds
  pop cx
  pop bx
  je cga
    ;Bild im Schneidermodus 2 abspeichern
  call vorspann
  mov si,offset schneider0
  call schreiben
    ;Lesen Seite 0
  mov dx,03deh
  mov al,0
  out dx,al
  call packen
  mov si,offset schneider1
  call schreiben
    ;Lesen Seite 1
  mov al,1
  out dx,al
  call packen
  mov si,offset schneider2
  call schreiben
    ;Lesen Seite 2
  mov al,2
  out dx,al
  call packen
  mov si,offset schneider3
  call schreiben
    ;Lesen Seite 3
  mov al,3
  out dx,al
  jmp packen

schneider0 dw schneider1-s0
s0:
    ;Alle 4 Bitplanes werden angezeigt
  mov dx,03d9h
  mov al,0fh
  out dx,al
    ;Schreiben Seite 0
  add dx,4
  mov al,1
  out dx,al
schneider1 dw schneider2-s1
s1:
    ;Schreiben Seite 1
  mov al,2
  out dx,al
schneider2 dw schneider3-s2
s2:
    ;Schreiben Seite 2
  mov al,4
  out dx,al
schneider3 dw schneidere-s3
s3:
    ;Schreiben Seite 3
  mov al,8
  out dx,al
schneidere = $

    ;Unterscheidung zwischen Hercules und MDA
hercules:
    ;Vom Benutzer erzwungener Herculesmodus
  cmp byte ptr hercmodus,0
  jne herc
  mov byte ptr hercseite,0
    ;Bit 1 und 7 der BIOS-Variable 40:65h auswerten
  push ds
  mov ax,40h
  mov ds,ax
  mov al,ds:[65h]
  pop ds
    ;Bit 1: 0=Text, 1=Grafik
  test al,2
  je hercules?
    ;Bit 7: 0=Seite 0, 1=Seite 1
  test al,128
  je herc
  mov byte ptr hercseite,1
  jmp short herc
    ;Herculeskarte auf Hardwarebasis suchen
hercules?:
    ;Lightpen-Flipflop setzen
  mov dx,03b9h
  out dx,al
    ;Bit 2 des Status-Port gesetzt?
  inc dx
  in al,dx
  test al,2
    ;Nein, dann kein Lightpen vorhanden
  je mda
    ;Lightpen-Flipflop lschen
  inc dx
  out dx,al
    ;Bit 2 gelscht?
  dec dx
  in al,dx
  test al,2
    ;Ja, dann Text-/Grafikmodus prfen
  je warte0
mda:
  jmp cga
    ;Warten auf Rasterstrahl im Bild
warte0:
  in al,dx
  test al,128
  je warte0
    ;Warten auf Rcklauf des Strahls
warte1:
  in al,dx
  test al,128
  jne warte1
    ;Flipflop set & reset
  inc dx
  out dx,al
  sub dx,2
  out dx,al
    ;Lightpenadresse lesen
  mov dx,03b4h
  mov al,16 ;<-- hier eventuell 17 einsetzen (Peacock Hercules)
  out dx,al
  inc dx
  in al,dx
  mov ah,al
  dec dx
  mov al,17 ;<-- hier eventuell 16 einsetzen
  out dx,al
  inc dx
  in al,dx
    ;Mit Schwellwert vergleichen
  cmp ax,2958
  jb mda
herc:
    ;Grafik => Paker auf Bytezugriff umstellen
  mov byte ptr wort,0
  call vorspann
  mov si,offset hercules0
  call schreiben
    ;BX := Seite * 32768
  mov al,hercseite
  mov ah,128
  mul ah
  mov bh,al
  mov cx,32494
  jmp packen

    ;Grafikmodus einschalten
hercules0 dw he-h0
h0:
    ;Karte in Half-Modus schalten
  mov dx,03bfh
  mov al,1
  out dx,al
  call h1
    ;Tabelle der Werte fr den 6845 (Hi=Wert, Lo=RegisterNr)
  dw 3500h,2d01h,2e02h,0703h,5b04h,0205h
  dw 5706h,5707h,0208h,0309h,000ah,000bh
h1:
  pop si
    ;6845 initialisieren
  mov cx,12
  mov dx,03b4h
h2:
  lodsw
  out dx,ax
  loop h2
    ;Controller auf Grafik schalten
  mov dx,03b8h
  mov al,10
  out dx,al
he = $

    ;Unterprogramm fr EGA/VGA mit 16 Farben
ega:
  call vorspann
    ;Im monochromen Modus 0Fh gibt es keine Palette
  cmp neuermodus,0fh
  je zweiteebene
  mov si,offset egafarben
  call schreiben
zweiteebene:
  mov si,offset ega0
  call schreiben
    ;Indexregister auf Read-Map-Select
  mov dx,03ceh
  mov al,4
  out dx,al
    ;Lesen Seite 0
  inc dx
  mov al,0
  out dx,al
  call packen
    ;Der monochrome Modus verwendet nur die Seiten 0 und 2
  cmp neuermodus,0fh
  je ueberspringe1
  mov si,offset ega1
  call schreiben
    ;Lesen Seite 1
  mov al,1
  out dx,al
  call packen
ueberspringe1:
    ;Der EVA-Spezialmodus 800*600*4 verwendet nur die Seiten 0 und 1
  cmp neuermodus,29h
  je ueberspringe3
  mov si,offset ega2
  call schreiben
    ;Lesen Seite 2
  mov al,2
  out dx,al
  call packen
  cmp neuermodus,0fh
  je ueberspringe3
  mov si,offset ega3
  call schreiben
    ;Lesen Seite 3
  mov al,3
  out dx,al
  call packen
ueberspringe3:
  and cx,cx
  jne egaende
  cmp neuermodus,37h
  jne egaende
    ;Beim EVA-Spezialmodus 1024*768*16 ist eine Seite 96 KByte gro und kann
    ;nicht in einem Rutsch abgespeichert werden
  mov videobasis,0b000h
  mov cx,32768
  mov si,offset evahires
  call schreiben
  jmp zweiteebene
egaende:
  ret

    ;Palette setzen
egafarben dw ega0-egaf0
egaf0:
  call egaf1
egapalette db 17 dup (0)
egaf1:
  pop dx
  push es
  push cs
  pop es
  mov ax,1002h
  int 10h
  pop es
ega0 dw ega1-e0
e0:
    ;Indexregister auf Map-Select
  mov dx,03c4h
  mov al,2
  out dx,al
    ;Schreiben Seite 0
  inc dx
  mov al,1
  out dx,al
ega1 dw ega2-e1
e1:
    ;Schreiben Seite 1
  mov al,2
  out dx,al
ega2 dw ega3-e2
e2:
    ;Schreiben Seite 2
  mov al,4
  out dx,al
ega3 dw evahires-e3
e3:
    ;Schreiben Seite 3
  mov al,8
  out dx,al
evahires dw egae-eh
eh:
    ;Fr EVA 1024*768*16 Bildschirmsegment neu laden
  mov ax,0b000h
  mov es,ax
egae = $

    ;Unterprogramm fr VGA-Modus 13h
vga:
  call vorspann
  call vgapalette
    ;Auf SCQ-Modus prfen
  push ds
  xor ax,ax
  mov ds,ax
  cmp byte ptr ds:[484h],18h
  pop ds
  jne scq
  jmp packen
    ;Bild im SCQ-Modus abspeichern
scq:
  mov cx,43200
  mov dx,03ceh
  mov al,04h
  out dx,al
  inc dx
    ;Schreibe Seite 2
  mov si,offset scqd0
  call schreiben
  mov al,2
  out dx,al
  call packen
    ;Schreibe Seite 1
  mov si,offset scqd1
  call schreiben
  mov al,1
  out dx,al
  call packen
    ;Schreibe Seite 3
  mov si,offset scqd2
  call schreiben
  mov al,3
  out dx,al
  call packen
    ;Schreibe Seite 0
  mov si,offset scqd3
  call schreiben
  mov al,0
  out dx,al
  jmp packen

scqd0 dw scqd1-scd0
scd0:
  call scq0
  db 45,0,59,8,0,48,117,1,1,15
  db 0,6,3,0,109,89,90,142,98,139,11,62
  db 0,64,0,0,0,0,0,0,234,140,223,45,0
  db 231,4,195,255,0,0,0,0,0,64,5,15,255
wortaus:
  xchg al,ah
  out dx,al
  inc dx
  xchg al,ah
  out dx,al
  dec dx
  inc ah
  ret
scq0:
  pop si
  push es
  push di
  xor ax,ax
  mov es,ax
  mov di,044ah
  movsw
  mov di,0484h
  movsb
  movsw
  mov di,044ch
  movsw
  pop di
  pop es
  cli
  mov dx,03c4h
  mov ah,0
scq1:
  lodsb
  call wortaus
  cmp ah,5
  jb scq1
  mov dl,0c2h
  mov al,199
  out dx,al
  mov dl,0c4h
  lodsw
  call wortaus
  sti
  mov dl,0d4h
  mov ax,17
  out dx,al
  inc dx
  in al,dx
  and al,7fh
  out dx,al
  dec dx
scq2:
  lodsb
  call wortaus
  cmp ah,25
  Jb scq2
  mov dl,0cch
  mov al,0
  out dx,al
  mov dl,0cah
  mov ax,1
  out dx,al
  mov dl,0ceh
scq3:
  lodsb
  call wortaus
  cmp ah,9
  jb scq3
scqd1 dw scqd2-scd1
scd1:
  mov dx,03c4h
  mov al,2
  out dx,al
  inc dx
  mov al,3
  out dx,al
scqd2 dw scqd3-scd2
scd2:
  mov al,8
  out dx,al
scqd3 dw scqd4-scd3
scd3:
  mov al,1
  out dx,al
scqd4 = $

    ;CGA-Grafikmodus in 16 Farben
cga16:
    ;Videomodus 7Ch verkraftet BIOS nicht
  mov neuermodus,3
  call vorspann
  mov si,offset mode16
  call schreiben
  jmp packen
mode16 dw end16-anf16
anf16:
  call getadr
    ;Parametersatz fr den 6845
  db 113,80,90,10,127,6,100,112,0,1,32
getadr:
  pop si
  mov dx,03d4h
  xor ah,ah
set6845:
  mov al,ah
  out dx,al
  inc dx
  lodsb
  out dx,al
  dec dx
  inc ah
  cmp ah,11
  jb set6845
    ;Reverse-Hilight statt Blinken
  mov dl,0d8h
  mov al,9
  out dx,al
    ;Videomodus residenten PRGs bekanntgeben
  push es
  xor ax,ax
  mov es,ax
  mov byte ptr es:[0449h],7ch
  pop es
end16 = $

    ;VGA-Palette lesen und auf Disk schreiben
vgapalette:
  mov si,offset vga0
  call schreiben
  push cx
  mov dx,03c7h
  xor al,al
  out dx,al
  inc dx
  inc dx
  mov cx,256
schreibedac:
  in al,dx
  call schreibeal
  in al,dx
  call schreibeal
  in al,dx
  call schreibeal
  loop schreibedac
  pop cx
  mov si,offset vga1
  jmp schreiben

    ;VGA-Palette setzen
vga0 dw vga1-v0
    ;Jmp $+768
v0 db 0e8h,0,3
vga1 dw vgae-v1
v1:
  pop dx
  push es
  push cs
  pop es
  mov ax,1012h
    ;BIOS-Funktion: Setze Block von Palettenregistern mit [ES:DX]
  xor bx,bx
  mov cx,256
  int 10h
  pop es
vgae = $

    ;Unterprogramm fr die beiden EVA-Modi mit 256 Farben
eva:
  call vorspann
  call vgapalette
  mov si,offset eva0
  call schreiben
    ;Lesen Seite 0
  mov dx,03cdh
    ;Bit 0..2 Schreibseite, Bit 3..5 Leseseite, Bit 6 immer gesetzt
  mov al,40h
  out dx,al
  call packen
  mov si,offset eva1
  call schreiben
    ;Lesen Seite 1
  mov al,48h
  out dx,al
  call packen
  mov si,offset eva2
  call schreiben
    ;Lesen Seite 2
  mov al,50h
  out dx,al
  call packen
  mov si,offset eva3
  call schreiben
    ;Lesen Seite 3
  mov al,58h
  out dx,al
  cmp neuermodus,2dh
  jne kein2d
  mov cx,27392
  jmp packen
kein2d:
  call packen
  mov si,offset eva4
  call schreiben
    ;Lesen Seite 4
  mov al,60h
  out dx,al
  cmp neuermodus,2eh
  jne kein2e
  mov cx,45056
  jmp packen
kein2e:
  ret

eva0 dw eva1-ev0
ev0:
    ;Schreiben Seite 0
  mov dx,03cdh
  mov al,40h
  out dx,al
eva1 dw eva2-ev1
ev1:
    ;Schreiben Seite 1
  mov al,41h
  out dx,al
eva2 dw eva3-ev2
ev2:
    ;Schreiben Seite 2
  mov al,42h
  out dx,al
eva3 dw eva4-ev3
ev3:
    ;Schreiben Seite 3
  mov al,43h
  out dx,al
eva4 dw evae-ev4
ev4:
    ;Schreiben Seite 4
  mov al,44h
  out dx,al
evae = $

    ;Daten fr den Header der EXE-Datei
exeheader dw exee-exe
exe dw "ZM",?,?,0,32,64,64,?,1024,0,0,0,30
exee = $

    ;Die folgende Routine zeigt spter das Bild an
vorspanndat dw vorspannende-differenz
differenz:
  cld
  push ds
  push cs
  pop ds
  jmp short modusein
    ;Auf Tastendruck warten, wenn Option "c" fehlt
taste:
  pop ds
  cmp word ptr ds:[5dh]," C"
  je nichtwarten
    ;Cursor ausschalten
  mov cx,2000h
  mov ah,01h
  int 10h
    ;Auf Taste warten
  mov ah,0
  int 16h
    ;Videomodus wiederherstellen
  mov ax,0
altermodus = byte ptr $-2
  int 10h
    ;Bild verlassen
nichtwarten:
  mov ah,4ch
  int 21h
    ;Eine Seite (maximal 64 KByte) entpacken
entpacken:
  xor di,di
  mov ch,0
entpack0:
    ;Quelldaten knnen unter widrigen Umstnden grer als 64 KByte sein,
    ;deshalb mu das Quellsegment bei Bedarf erhht werden
  cmp si,8000h
  jb entpack1
  sub si,8000h
  mov ax,ds
  add ax,0800h
  mov ds,ax
    ;Neue Anweisung lesen
entpack1:
  lodsb
  mov cl,al
  cmp cl,128
    ;Positiv: CX Werte bertragen
  jb entpack2
    ;128: Seite fertig
  je entpack3
    ;Negativ: Folgender Wert wiederholt sich - CX mal
w0:
  lodsb
  neg cl
    ;Rep-Prfix wegen des variablen Byte-/Wort-Zugriffs als Datum
  db 0f3h
w1:
  stosb
  jmp entpack0
    ;Werte kopieren
entpack2:
  db 0f3h
w2:
  movsb
  jmp entpack0
    ;Seite fertig
entpack3:
    ;DS fr nchste Seite normalisieren
  mov di,si
  mov cl,4
  shr di,cl
  mov ax,ds
  add ax,di
  mov ds,ax
    ;Sprung zur ersten Adresse hinter den Daten
  push ax
  and si,15
  push si
    ;Ret-Far
  db 0cbh
    ;Alten Modus retten
modusein:
  mov ah,0fh
  int 10h
    ;Variablenzugriff zur Laufzeit!
  mov ds:[altermodus-differenz],al
    ;Neuen Modus einschalten
  mov ax,0
neuermodus = byte ptr $-2
  int 10h
    ;Zielsegment setzen
  mov ax,0
videobasis = word ptr $-2
  mov es,ax
  push cs
vorspannende = $

    ;Programmblock zwischen den einzelnen Bildseiten
neueebene dw nee-ne0
ne0:
    ;SI auf Datenblock setzen
  call ne1
ne1:
  pop si
  add si,nee-ne1
    ;Adresse des Entpackers auf Stack
  pop ax
  push ax
  push ax
  mov ax,entpacken-differenz
  push ax
    ;Ret Far
  db 0cbh
nee = $

    ;Sprung zum Programmende
nachspann dw nse-ns
ns:
  mov ax,taste-differenz
  push ax
  db 0cbh
nse = $

    ;Flag fr Wortzugriff
wort db 0
    ;Adressen der Byte-/Wort-Befehle
worte dw w0,w1,w2,w3,w4,w5,w6,w7,w8,w9,0
handle dw ?

    ;Entpacker auf Disk schreiben
vorspann:
    ;Befehle an Byte-/Wortzugriff anpassen
  mov si,offset worte
  push di
neuerbefehl:
  lodsw
  and ax,ax
    ;Adresse=0 => Ende
  je befehlende
  mov di,ax
  mov al,ds:[di]
    ;Bit 0 des Befehls ist fr Wortzigriff verantwortlich
  and al,0feh
  or al,wort
  mov ds:[di],al
  jmp neuerbefehl
befehlende:
  pop di
  mov si,offset vorspanndat
    ;Datenblock [DS:SI] auf Disk schreiben
schreiben:
  push cx
  lodsw
  mov cx,ax
  jcxz datenende
neuesdatum:
  lodsb
  call schreibeal
  loop neuesdatum
datenende:
  pop cx
  ret

    ;CX Bytes ab [VideoBasis:BX] gepackt auf Diskette schreiben
packen:
    ;Aufruf des Entpackers schreiben
  mov si,offset neueebene
  call schreiben
  push bx
  push cx
  push dx
  push ds
  mov ds,videobasis
  mov si,bx
  add cx,bx
    ;Endevergleich beim 1. Mal berspringen (fr 64 KByte-Blcke)
  jmp short ersterblock
neuerblock:
    ;Ende erreicht?
  cmp si,cx
  je packende
ersterblock:
  push si
    ;Bytezhler initialisieren
  mov dl,0
w3:
    ;Ersten Wert holen
  lodsb
  mov bx,ax
  jmp short pruefeende
w4:
    ;Nchsten Wert holen
  lodsb
  xchg ax,bx
w5:
    ;Mit vorigem Wert vergleichen
  cmp bl,al
  je gleich
  inc dl
    ;Maximal 127 verschiedene Werte knnen an einem Stck verarbeitet werden
  cmp dl,127
  je schreibedl
pruefeende:
  cmp si,cx
  jne w4
  inc dl
    ;Zhler und Werte auf Disk schreiben
schreibedl:
  pop si
  mov al,dl
  call schreibeal
w6:
  lodsb
  call schreibeax
  dec dl
  jne w6
  jmp neuerblock
gleich:
    ;Falls Zhler > 0, dann zuerst Werte schreiben
  cmp dl,0
  jne schreibedl
    ;Zwei Werte sind bereits gleich
  mov dl,-2
pruefefertig:
  cmp si,cx
  je ungleich
w7:
    ;Nchsten Wert holen
  lodsb
w8:
    ;Auf Gleichheit prfen
  cmp al,bl
  jne ungleich
  dec dl
    ;Maximal 127 gleiche Werte knnen an einem Stck verarbeitet werden
  cmp dl,-127
  jne pruefefertig
ungleich:
    ;Zhler und sich wiederholender Wert auf Disk schreiben
  mov al,dl
  call schreibeal
  pop si
w9:
  lodsb
  inc dl
  jne w9
  call schreibeax
  jmp neuerblock
packende:
    ;Endekennzeichen schreiben
  mov al,128
  call schreibeal
  pop ds
  pop dx
  pop cx
  pop bx
  ret

    ;Byte oder Wort in AX schreiben, je nach Wert in "Wort"
schreibeax:
  cmp cs:[wort],0
  je schreibeal
  push ax
  call schreibeal
  pop ax
  mov al,ah
    ;AL in Puffer schreiben
schreibeal:
  stosb
    ;Puffer voll?
  cmp di,256
  jb schreibeende
    ;Puffer auf Disk schreiben
schreibeblock:
  and di,di
  je schreibeende
  push bx
  push cx
  push dx
  push ds
  mov bx,cs:handle
  mov cx,di
  push cs
  pop ds
  xor dx,dx
  mov ah,40h
  int 21h
  pop ds
  pop dx
  pop cx
  pop bx
    ;Bei Fehlern ist das Carryflag gesetzt
  jc schliessen
    ;Prfen ob Diskette voll
  cmp ax,di
  jne schliessen
    ;Puferzeiger zurcksetzen
  xor di,di
schreibeende:
  ret
schliessen:
  mov bx,handle
  mov ah,3eh
  int 21h
fehler:
    ;Fiepen
  mov ax,0e07h
  int 10h
    ;Rckkehr zum Hauptprogramm
  mov sp,bp
  ret

hauptprogramm:
    ;Stackpointer fr Fehlerrckkehr sichern
  mov bp,sp
  mov al,usermodus
  mov bh,userseite
    ;Moduserkennung auf Automatik?
  cmp byte ptr automodus,0
  je manuell
    ;Aktuellen Videomodus und Seite holen
  mov ah,0fh
  int 10h
manuell:
    ;Videomodus in Tabelle suchen
  mov si,offset videomodi
vergleichen:
  cmp al,ds:[si]
  je gefunden
  add si,lengthvideo
  cmp si,offset videoende
  jb vergleichen
  jmp fehler
gefunden:
  mov neuermodus,al
    ;Datei ffnen, Attribut: Archive
  mov cl,20h
  mov dx,offset pfad
  mov ah,3ch
  int 21h
  mov handle,ax
  jnc oeffnenok
fehler0:
  jmp fehler
oeffnenok:
    ;Pufferzeiger auf 0 setzen, Puffer ist nutzloser PSP
  xor di,di
    ;Unrelevante Werte im EXE-Kopf mit 0 fllen
  mov cx,512
schreibenull:
  mov al,0
  call schreibeal
  loop schreibenull
    ;Videomodus berlesen
  lodsb
    ;Bildschirmsegment lesen
  lodsw
  mov videobasis,ax
    ;Seitenfaktor mit aktueller Seite multiplizieren
  lodsb
  mul bh
  mov bl,0
    ;und mit 256 malnehmen
  mov bh,al
    ;Bytes pro Seite holen
  lodsw
  mov cx,ax
    ;Flag fr Wortzugriff holen
  lodsb
  mov wort,al
    ;Unterprogramm aufrufen
  lodsw
  call ax
  mov si,offset nachspann
  call schreiben
    ;Eventuelle Werte im Puffer auf Disk schreiben
  call schreibeblock
    ;Dateilnge nach DX:AX holen
  mov ax,4202h
  mov bx,handle
  xor cx,cx
  xor dx,dx
  int 21h
  jc fehler0
    ;Anzahl der Bytes in der letzten Seite
  push ax
  and ax,511
  jne nichtvoll
  mov ax,512
nichtvoll:
  mov exe+2,ax
  pop ax
    ;Anzahl der 512-Byte-Seiten bestimmen
  push ax
  push dx
  add ax,511
  adc dx,0
  mov cx,512
  div cx
  mov exe+4,ax
  pop dx
  pop ax
    ;Stacksegment berechnen
  sub ax,497
  sbb dx,0
  mov cx,16
  div cx
  mov exe+14,ax
    ;Dateizeiger auf Anfang setzen
  mov ax,4200h
  xor cx,cx
  xor dx,dx
  int 21h
  jc fehler0
    ;Exe-Header schreiben
  mov si,offset exeheader
  call schreiben
  call schreibeblock
    ;Datei schlieen
  mov bx,handle
  mov ah,3eh
  int 21h
  jnc schliessenok
  jmp fehler
schliessenok:
    ;Ende des Dateinamens suchen
  mov si,offset pfad
suchenull:
  lodsb
  cmp al,0
  jne suchenull
  std
  lodsb
    ;Rckwrts nach Ziffern suchen
pruefeziffer:
  cmp si,offset pfad
  jb ende
  lodsb
    ;Abbruch bei einem Subdirectory
  cmp al,"\"
  je ende
  cmp al,"0"
  jb pruefeziffer
  cmp al,"9"
  ja pruefeziffer
    ;Gefundene Ziffer weiterzhlen
  inc al
  mov ds:[si+1],al
  cmp al,"9"
  jbe ende
    ;Bei berlauf von "9" auf "0" nchste Ziffer suchen
  mov byte ptr ds:[si+1],"0"
  jmp pruefeziffer
ende:
  ret

    ;Neue bzw. gerettete Interruptvektoren
alterint05 dw neuerint05,?
alterint10 dw neuerint10,?
alterint19 dw neuerint19,?
alterint09 dw neuerint09,?
alterint08 dw neuerint08,?
alterint28 dw neuerint28,?
alterint24 dw neuerint24,?
    ;Zeiger auf Flag, das den Aufruf von DOS-Funktionen erlaubt
indosflag dw ?,?
    ;Verschiedene Schalterzustnde
usermodus db 0
userseite db 0
automodus db -1
hercmodus db 0
hercseite db 0
    ;Flag fr ALT gedrckt (nur beim PC)
altflag db 0
    ;Flag fr PrtSc verboten
aktiv db 0

    ;Hotkey erkennen
neuerint05:
  assume ds:nothing

neuerint09:
  push ax
if intnr eq 9
    ;Scan-Cde der gedrckten Taste lesen
  in al,60h
    ;Wurde Alt gedrckt?
  cmp al,38h
  jne keinaltein
  mov altflag,-1
  jmp short int09alt
keinaltein:
    ;Wurde Alt losgelassen?
  cmp al,0B8h
  jne keinaltaus
  mov altflag,0
  jmp short int09alt
keinaltaus:
  cmp al,54h
  je sysrequest
    ;Ist die Taste PrtSc?
  cmp al,37h
  jne int09alt
    ;Ja: Ist gleichzeitig Alt gedrckt?
  cmp altflag,0
    ;Nein, dann zur alten Tastaturroutine
  je int09alt
sysrequest:
endif
    ;Abbruch, wenn Programm bereits aktiv
  cmp aktiv,0
  jne adios
  mov aktiv,-1
  push si
  push di
    ;Ticker- und Dosfree-Interrupt setzen
  call int08und28
  pop di
  pop si
adios:
if intnr eq 5
  pop ax
  iret
else
    ;Empfangene Taste besttigen
  in al,61h
  or al,128
  out 61h,al
  and al,127
  out 61h,al
    ;Interruptausfhrung besttigen
  mov al,61h
  out 20h,al
  pop ax
  iret
int09alt:
  pop ax
  jmp dword ptr alterint05
endif

    ;Standardpalette fr EGA und VGA
egastandard db 0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63,0

    ;Neuer Videointerrupt
neuerint10:
  and ah,ah
  je modussetzen
  cmp ah,0bh
  je cgafarben
  cmp ah,10h
  jae egaodervga
raushier:
  jmp dword ptr alterint10
    ;Neuen Videomodus einschalten
modussetzen:
    ;CGA- und EGA-Farben auf Standartwerte setzen
  mov blinken,1
  mov cgarand,16
  mov cgapalette,0
  push ax
  push bx
  mov bx,16
naechstefarbe:
  mov al,[egastandard+bx]
  mov [egapalette+bx],al
  dec bl
  jns naechstefarbe
  pop bx
  pop ax
  jmp raushier
    ;CGA-Randfarbe bzw. Palette setzen
cgafarben:
  cmp bh,0
  jne keinrand
  mov cgarand,bl
  jmp raushier
keinrand:
  mov cgapalette,bl
  jmp raushier
egaodervga:
  cmp ax,1000h
  jne overscan
    ;Einzelnes Palettenregister setzen
  cmp bl,16
  jae raushier
  push di
  mov di,bx
  and di,255
  mov [egapalette+di],bh
  pop di
  jmp raushier
overscan:
  cmp ax,1001h
  jne farbblock
    ;Randfarbe setzen
  mov egapalette+16,bh
  jmp raushier
farbblock:
  cmp ax,1002h
  jne blinktest
    ;Komplette Farbpalette neu setzen
  push ax
  push bx
  push di
  mov di,dx
  mov bx,16
neuefarbe:
  mov al,es:[di+bx]
  mov [egapalette+bx],al
  dec bl
  jns neuefarbe
  pop di
  pop bx
  pop ax
  jmp raushier
blinktest:
  cmp ax,1003h
  jne raus
  mov blinken,bl
raus:
  jmp raushier

    ;Interrupts bei Warmstart deaktivieren
neuerint19:
  call int05und19
  int 19h

    ;Neuer Ticker-Interrupt bei aktiviertem Programm
neuerint08:
    ;Alte Routine bedienen
  pushf
  call dword ptr alterint08
  push ds
  push si
    ;Sind DOS-Aufrufe erlaubt?
  lds si,dword ptr indosflag
  cmp byte ptr ds:[si],0
  pop si
  pop ds
  jne geduld
    ;Neuer Dosfree-Interrupt bei aktiviertem Programm
neuerint28:
  push ax
  push bx
  push cx
  push dx
  push si
  push di
  push bp
  push ds
  push es
    ;Ticker- und Dosfree-Interrupt restaurieren
  call int08und28
    ;Interrupts zulassen
  sti
    ;Fehlerbehandlungsroutine fr Schreibfehler setzen (erst ab DOS 3.0)
  call int24
  mov ax,cs
  mov es,ax
  call hauptprogramm
    ;Fehlerbehandlung restaurieren
  call int24
  pop es
  pop ds
  pop bp
  pop di
  pop si
  pop dx
  pop cx
  pop bx
  pop ax
    ;Neuen Aufruf ermglichen
  mov aktiv,0
geduld:
  iret

    ;Schreibfehlerbehandlung
neuerint24:
    ;Code 3 entspricht (I)gnorieren
  mov al,3
  iret

    ;Hotkey-Erkennung ein-/ausschalten
int05und19:
if intnr eq 5
  mov di,05h*4
else
  mov di,09h*4
endif
  mov si,offset alterint05
  call interrupt
  mov di,10h*4
  mov si,offset alterint10
  call interrupt
  mov di,19h*4
  mov si,offset alterint19
  jmp short interrupt
    ;Warten auf freies DOS ein-/ausschalten
int08und28:
  push ds
  push es
  mov di,08h*4
  mov si,offset alterint08
  call interrupt
  mov di,28h*4
  mov si,offset alterint28
  call interrupt
  pop es
  pop ds
  ret
    ;Fehlerbehandlung ein-/ausschalten
int24:
  mov di,24h*4
  mov si,offset alterint24
    ;Interruptvektor mit gesichertem Vektor vertauschen
interrupt:
  cld
  mov ax,cs
  mov ds,ax
  xor ax,ax
  mov es,ax
  call vertauschen
vertauschen:
  mov ax,es:[di]
  movsw
  mov ds:[si-2],ax
  ret

    ;Dateiname beim ersten Aufruf ohne Namensangabe
pfad db "BILD0.EXE",0

installieren:
  assume ds:code
  mov si,offset programmname
  call write
    ;Segmentadresse der neuen Interruptprozeduren setzen
  mov di,offset alterint05+2
  mov ax,cs
  mov cx,7
setzesegment:
  stosw
  add di,2
  loop setzesegment
    ;Prfen, ob Programm schon installiert ist
  mov ax,3500h+intnr
  int 21h
if intnr eq 5
  mov si,offset neuerint05
else
  mov si,offset neuerint09
endif
  mov di,bx
  mov cx,32
  repe cmpsw
  je schonda
  mov si,offset installmeldung
  call write
    ;Hotkey-Erkennung einschalten
  cli
  call int05und19
    ;Adresse des InDosFlags holen
  mov ah,34h
  int 21h
  mov indosflag,bx
  mov indosflag+2,es
    ;Schaltervariablen liegen im aktuellen Code-Segment
  push cs
  pop es
    ;Dateinamen und Schalter lesen
schonda:
  mov si,128
  lodsb
    ;Parameterstring mit 0 abschlieen
  mov ah,0
  add si,ax
  mov byte ptr ds:[si],0
  mov si,129
    ;Leerzeichen berlesen
leerzeichen:
  lodsb
  cmp al,0
  je keinparam0
  cmp al," "
  je leerzeichen
  cmp al,"/"
  je schalter
    ;Dateinamen bertragen
  mov di,offset pfad
    ;Maximal 63 Zeichen mit Null-Abschlu
  mov ah,64
uebertragen:
  dec ah
  jne pfadok
  mov si,offset laengefehler
  call write
keinparam0:
  jmp keinparameter
pfadok:
    ;Der Name wird mit 0, Leerzeichen oder "/" beendet
  cmp al,0
  je keinparam0
  cmp al,"/"
  je schalter
  cmp al," "
  je neuerschalter0
    ;Kleinbuchstaben in Grobuchstaben wandeln
  cmp al,"a"
  jb nichtwandeln
  cmp al,"z"
  ja nichtwandeln
  and al,255-32
nichtwandeln:
  stosb
    ;Namen mit 0 abschlieen
  mov byte ptr es:[di],0
    ;Nchstes Zeichen prfen
  lodsb
  jmp uebertragen
schalter:
  lodsb
    ;Schalter in Kleinbuchstaben wandeln
  or al,32
  cmp al,"a"
  jne keinautomatik
  mov es:[automodus],-1
neuerschalter0:
  jmp neuerschalter
keinautomatik:
  cmp al,"h"
  jne keinhercmodus
  mov es:[hercmodus],-1
    ;Ist eine Seite bei "/h" angegeben?
  lodsb
  cmp al,","
  jne sucheschalter
  lodsb
    ;Mgliche Seiten sind 0 und 1
  cmp al,"0"
  je hercseiteok
  cmp al,"1"
  je hercseiteok
  jmp falscheoption
hercseiteok:
  sub al,"0"
  mov es:[hercseite],al
  jmp short neuerschalter
schalter0:
  jmp schalter
keinhercmodus:
  cmp al,"m"
  jne keinmdamodus
  mov es:[hercmodus],0
  jmp short neuerschalter
keinmdamodus:
    ;Ist der Schalter eine gltige Hexadezimalziffer?
  call hexziffer
  jc falscheoption0
  mov cl,4
  shl al,cl
  push ax
    ;Zweite Hexziffer holen
  lodsb
  or al,32
  call hexziffer
  pop cx
  jc falscheoption0
  or al,cl
    ;Ist der angegebene Modus bekannt?
  mov bx,offset videomodi
suche:
  cmp al,es:[bx]
  je modusbekannt
  add bx,lengthvideo
  cmp bx,offset videoende
  jb suche
  mov si,offset modusfehler
  jmp short fehlerausgabe
modusbekannt:
  mov es:[usermodus],al
  mov es:[automodus],0
    ;Ist auerdem noch eine Seite angegeben?
  lodsb
  cmp al,","
  jne sucheschalter
  lodsb
  call hexziffer
falscheoption0:
  jc falscheoption
  mov es:[userseite],al
    ;Folgt eine weitere Schalterangabe?
neuerschalter:
  lodsb
sucheschalter:
  cmp al,0
  je keinparameter
  cmp al," "
  je neuerschalter
  cmp al,"/"
  je schalter0
  mov si,offset syntaxfehler
fehlerausgabe:
  call write
keinparameter:
    ;Einschaltmeldungen ausgeben
  sti
  mov si,offset pfadmeldung
  call write
  push ds
  push es
  pop ds
  mov si,offset pfad
  call write
  pop ds
  mov si,offset modusmeldung
  call write
  cmp es:[automodus],0
  jne automatik
  mov dl,es:[usermodus]
  push dx
  mov cl,4
  shr dl,cl
  call writehex
  pop dx
  and dl,15
  call writehex
  mov si,offset seitemeldung
  call write
  mov dl,es:[userseite]
  call writehex
  jmp short crlf
falscheoption:
  mov si,offset schalterfehler
  jmp fehlerausgabe
automatik:
  mov si,offset automeldung
  call write
crlf:
  mov si,offset linefeed
  call write
  cmp es:[hercmodus],0
  je keinhercgrafik
  mov si,offset hercmeldung1
  call write
  mov dl,es:[hercseite]
  call writehex
  mov si,offset hercmeldung2
  call write
keinhercgrafik:
    ;Ist es ein Erstaufruf?
  mov ax,cs
  mov bx,es
  cmp ax,bx
  jne zurueck
    ;Ja, dann resident installieren
  mov dx,offset pfad+64
  int 27h
zurueck:
  mov ah,4ch
  int 21h

    ;Den String [DS:SI] ausgeben, abschlu mit 0
writeit:
  mov dl,al
  mov ah,06h
  int 21h
write:
  lodsb
  and al,al
  jne writeit
  ret

    ;Das ASCII-Zeichen in AL auf gltige Hexziffer prfen
hexziffer:
  sub al,"0"
  jc hexfehler
  cmp al,10
  jb hexende
  cmp al,48
  jbe hexfehler
  sub al,39
  cmp al,15
  ja hexfehler
hexende:
  clc
  ret
hexfehler:
  stc
  ret

    ;Eine hexadezimale Ziffer ausgeben
writehex:
  and dl,15
  add dl,"0"
  cmp dl,"9"
  jbe keinbuchstabe
  add dl,7
keinbuchstabe:
  mov ah,02h
  int 21h
  ret

programmname db 10,"SnapShot Version 2.7",0
installmeldung db " installiert. Aufruf mit "
if intnr eq 5
  db "<PrtSc>",0
else
  db "<Alt-PrtSc> bzw. <SysReq>",0
endif
laengefehler db 13,10,"Fehler: Der angegebene "
  db "Pfad ist lnger als 62 Zeichen",0
schalterfehler db 13,10,"Fehler: Erlaubte Optionen sind "
  db "/Modus[,Seite], /A, /H[,Seite] und /M",0
modusfehler db 13,10,"Fehler: Der angegebene "
  db "Videomodus ist nicht bekannt",0
syntaxfehler db 13,10,"Fehler: Syntax "
  db "ist Snapshot [Pfad] [/Optionen]",0
pfadmeldung db 13,10,"  Aktueller Dateiname: ",0
modusmeldung db 13,10,"  Eingestellter Modus: ",0
seitemeldung db ", Seite ",0
automeldung db "Automatische Erkennung",0
hercmeldung1 db "  Im Modus 07 wird die Herculesgrafik "
  db "auf Seite ",0
hercmeldung2 db " gespeichert"
linefeed db 13,10,0

code ends
end begin
